/*
 * Created on Apr 1st, 2005
 *
 * Comments, questions: 
 *	Pierre-Guillaume.Raverdy@inria.fr
 *	Rafik.Chibout@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


package org.msda.components.interfaces;

import org.msda.msd.MSDDescription;
import org.msda.msd.MSDRequest;

/**
 * Client interface for the implentations of the MSDA service 
 * 
 * @author rafik.chibout@inria.fr - INRIA ARLES
 */
public interface MSDAServiceInterface 
{
	/**
	 * Returns the descriptions of the services matching the request
	 * 
	 * @param request description of the wanted service
	 * @return list of service descriptions matching the request
	 */
	MSDDescription[] getServices(MSDRequest request);

	/**
	 * Sends an access message to the MSDA service that must be forwarded to the targeted service
	 * 
	 * @param accessMessage access message for the final service (in SOAP, Jini, ...)
	 * @param descId ID of the ervice description of the targeted service (this identifies also the client)
	 * @param epService
	 * @return the value returned by the service in tha appropriate format
	 */
	String serviceAccess(String accessMessage, String descId, String epService);
}
