/*
 * Created on Sep 6, 2004
 *
 * Comments, questions: 
 *	Pierre-Guillaume.Raverdy@inria.fr
 *	Rafik.Chibout@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


package org.msda.components.interfaces;

import org.msda.msd.*;

/**
 * This interface, implemented by the MSD manager, is used by specific SD plugins to communicate 
 * with the MSD manager in order to provide SD related information.
 * 
 * @author raverdy
 */
public interface PluginCallback {  

	/**
	 * Returns a new MSD description, initialized with the creation information
	 * 
	 * @return the new msd description to be filed by the SD plugin
	 */
	public MSDDescription newMSDDescription ();

	/**
	 * Returns the MSD description associated with a local service by providing its unique ID
	 * <p>
	 * TODO check that this method is really necessary.
	 * 
	 * @param id the unique ID of the requested service
	 * @return the MSD description of the requested service
	 */
//	public MSDDescription getLocalService (String id);

	/**
	 * Registers a new service (in the MSD Manager) by providing its msd description
	 * 
	 * @param description : description received from the MSD group. May come from the MSD manager or from MSD bridges 
	 */
	public void newService (MSDDescription description );

	/**
	 * Cancels a service registerd (in the msd manager) by providing its unique id
	 * 
	 * @param id the unique id of the service to cancel
	 * @return true if service cancelled, false otherwise.
	 */
	public boolean endService ( String id );

}


