/*
 * Created on Sep 19, 2005
 *
 * Comments, questions: 
 *	Pierre-Guillaume.Raverdy@inria.fr
 *	Rafik.Chibout@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


package org.msda.components.manager;

import java.util.HashMap;

import org.msda.util.InfoType;

/**
 * Manages the cache that keeps MSD description id and the set of information required to provide service access
 * 
 * @author agnes.de_la_chapelle@inria.fr - INRIA ARLES
 *
 */
public class SvcAccessCacheMgr {

    private HashMap svcaccCache;
    
    public SvcAccessCacheMgr() {
        this.svcaccCache = new HashMap();
    }
    
    /**
     * Adds (MSD description id,  SvcAccessCacheObject) in the cache
     * 
     * @param msdDescId
     * @param o
     */
    public void add( String msdDescId, SvcAccessCacheObject o ) {
        this.svcaccCache.put( msdDescId, o );
    }
    
    /**
     * Gets the set of information required corresponding to a MSD description id 
     * 
     * @param msdDescId
     * @return
     */
    public SvcAccessCacheObject get( String msdDescId ) {
        SvcAccessCacheObject object = (SvcAccessCacheObject)this.svcaccCache.get( msdDescId );
        if ( object!=null ) {
            long diff = System.currentTimeMillis() - object.getCreationTime();
            if ( diff > InfoType.SVC_ACCESS_CACHE_TIMEOUT ) {
                this.svcaccCache.remove( msdDescId );
                return null;
            }
        }
        
        return object;
    }
}
