/*
 * Created on Apr 22, 2005
 *
 * Comments, questions: 
 *	Pierre-Guillaume.Raverdy@inria.fr
 *	Rafik.Chibout@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


package org.msda.components.manager.object;


import org.msda.msd.MSDRequest;

/**
 * This object is put in the queue to wake up a thread that processes a client request.<br>
 * 
 * @author agnes.de_la_chapelle@inria.fr - INRIA ARLES
 */
public class ObjectLocalRequest extends Object4Queue {

    private MSDRequest request;
    private long clientTimeout;
    private boolean existPendingRequest;
   
    public ObjectLocalRequest() {
        super();
        super.setType( Object4Queue.LOCAL_REQUEST );
    }
    
    
    /**
     * Returns true if the pending request already exists, false if the pending request has just been created
     * 
     * @return Returns the existPendingRequest.
     */
    public boolean isExistPendingRequest() {
        return existPendingRequest;
    }
    /**
     * Sets true if the pending request already exists, false if the pending request has just been created
     * 
     * @param existPendingRequest The existPendingRequest to set.
     */
    public void setExistPendingRequest(boolean existPendingRequest) {
        this.existPendingRequest = existPendingRequest;
    }
    /**
     * Returns the MSD request.
     * 
     * @return Returns the request.
     */
    public MSDRequest getRequest() {
        return request;
    }
    /**
     * Sets the MSD request. 
     * 
     * @param request The request to set.
     */
    public void setRequest(MSDRequest request) {
        this.request = request;
    }
    
    /**
     * Returns the client timeout for the request.
     * 
     * @return Returns the clientTimeout.
     */
    public long getClientTimeout() {
        return clientTimeout;
    }
    /**
     * Sets the client timeout for the request.
     * 
     * @param clientTimeout The clientTimeout to set.
     */
    public void setClientTimeout(long clientTimeout) {
        this.clientTimeout = clientTimeout;
    }
}
