/*
 * Created on May 19, 2005
 *
 * Comments, questions: 
 *	Pierre-Guillaume.Raverdy@inria.fr
 *	Rafik.Chibout@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


package org.msda.components.manager.object;

import org.msda.msd.MSDRequest;

/**
 * This object is added to the queue that will wake up a thread
 * that is able to manage a plugin for the requests and service accesses.
 * 
 * @author agnes.de_la_chapelle@inria.fr - INRIA ARLES
 */
public class ObjectPlugin extends Object4Queue {
    
    private String soapMessage;
    private String epService;
    
    private MSDRequest request;
    private boolean remote;
    
    public ObjectPlugin() {
        super.setType( Object4Queue.PLUGIN );
    }
    
    /**
     * Returns true if the request is a remote request, false otherwise.
     * 
     * @return Returns true if the request is remote, false otherwise.
     */
    public boolean isRemote() {
        return remote;
    }
    /**
     * Sets true if the request is a remote request, false otherwise.
     * 
     * @param remote The remote to set.
     */
    public void setRemote(boolean remote) {
        this.remote = remote;
    }
   
    /**
     * Returns the service endpoint reference.
     * 
     * @return Returns the epService.
     */
    public String getEpService() {
        return epService;
    }
    /**
     * Sets the service endpoint reference. 
     * 
     * @param epService The epService to set.
     */
    public void setEpService(String epService) {
        this.epService = epService;
    }
    /**
     * Returns the MSD request.
     * 
     * @return Returns the MSD request.
     */
    public MSDRequest getRequest() {
        return request;
    }
    /**
     * Sets the MSD request.
     * 
     * @param request The request to set.
     */
    public void setRequest(MSDRequest request) {
        this.request = request;
    }
    /**
     * Returns the SOAP message.
     * 
     * @return Returns the soapMessage.
     */
    public String getSoapMessage() {
        return soapMessage;
    }
    /**
     * Sets the SOAP message.
     * 
     * @param soapMessage The soapMessage to set.
     */
    public void setSoapMessage(String soapMessage) {
        this.soapMessage = soapMessage;
    }
}
