/*
 * Created on 15 juin 2005
 *
 * Comments, questions: 
 *	Pierre-Guillaume.Raverdy@inria.fr
 *	Rafik.Chibout@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


package org.msda.components.manager.object;

import java.net.Socket;

import org.msda.msd.MSDMessage;
import org.msda.msd.UbisecID;

/**
 * This object is put in the queue to wake up a thread that will process a remove service access.
 * 
 * @author agnes.de_la_chapelle@inria.fr - INRIA ARLES
 */
public class ObjectRemoteAccess extends Object4Queue {

	private MSDMessage message;
	private UbisecID networkID;
	private int port;
	private Socket socket;
	private String IPAddress;
	
	public ObjectRemoteAccess() {
	    super.setType( Object4Queue.REMOTE_ACCESS );
	}
	
	
    /**
     * @return Returns the iPAddress.
     */
    public String getIPAddress() {
        return IPAddress;
    }
    /**
     * @param address The iPAddress to set.
     */
    public void setIPAddress(String address) {
        IPAddress = address;
    }
    /**
     * @return Returns the socket.
     */
    public Socket getSocket() {
        return socket;
    }
    /**
     * @param socket The socket to set.
     */
    public void setSocket(Socket socket) {
        this.socket = socket;
    }
	/**
	 * @return Returns the message.
	 */
	public MSDMessage getMessage() {
		return message;
	}
	/**
	 * @param message The message to set.
	 */
	public void setMessage(MSDMessage message) {
		this.message = message;
	}
	/**
	 * Returns the network ID
	 * 
	 * @return Returns the networkID.
	 */
	public UbisecID getNetworkID() {
		return networkID;
	}
	/**
	 * Sets the network ID
	 * 
	 * @param networkID The networkID to set.
	 */
	public void setNetworkID(UbisecID networkID) {
		this.networkID = networkID;
	}
}
