/*
 * Created on Apr 21, 2005
 *
 * Comments, questions: 
 *	Pierre-Guillaume.Raverdy@inria.fr
 *	Rafik.Chibout@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


package org.msda.components.manager.object;


import org.msda.msd.MSDDescription;
import org.msda.msd.MSDRequest;

/**
 * This object is put in the queue to wake up a thread 
 *    - that can processe a remote client request,<br>
 *    - that will forward back the result of the request. <br>
 * 
 * @author agnes.de_la_chapelle@inria.fr - INRIA ARLES
 */
public class ObjectRemoteRequest extends Object4Queue {

    private int requestId;
    private MSDRequest request;
    private MSDDescription description;
    
    public ObjectRemoteRequest() {
        super.setType( Object4Queue.REMOTE_REQUEST );
    }
    
    /**
     * Returns the MSD description
     * 
     * @return Returns the description.
     */
    public MSDDescription getDescription() {
        return description;
    }
    /**
     * Sets the MSD description
     * 
     * @param description The description to set.
     */
    public void setDescription(MSDDescription description) {
        this.description = description;
    }
   
    /**
     * Returns the MSD request.
     * 
     * @return Returns the request.
     */
    public MSDRequest getRequest() {
        return request;
    }
    /**
     * Sets the MSD request.
     * 
     * @param request The request to set.
     */
    public void setRequest(MSDRequest request) {
        this.request = request;
    }
    /**
     * Returns the request id
     * 
     * @return Returns the requestId.
     */
    public int getRequestId() {
        return this.requestId;
    }  
    /**
     * Sets the request id
     * 
     * @param requestId The requestId to set.
     */
    public void setRequestId(int requestId) {
        this.requestId = requestId;
    }
}
