/*
 * Created on May 3, 2005
 *
 * Comments, questions: 
 *	Pierre-Guillaume.Raverdy@inria.fr
 *	Rafik.Chibout@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


package org.msda.components.manager.object;


import java.util.List;

import org.msda.msd.MSDMessage;

/**
 * This object is added to the queue that will wake up a thread
 * that processes service access from a local client.
 * 
 * @author agnes.de_la_chapelle@inria.fr - INRIA ARLES
 */
public class ObjectServiceAccess extends Object4Queue {

    private MSDMessage message;
    private boolean initialized;
    private String response;
    private List hops;

    public ObjectServiceAccess() {
        super.setType( Object4Queue.SERVICE_ACCESS );
        this.initialized = false;
    }
    
    /**
     * Returns the list of hops
     * 
     * @return Returns the hops.
     */
    public List getHops() {
        return hops;
    }
    /**
     * Sets the list of hops
     * 
     * @param hops The hops to set.
     */
    public void setHops(List hops) {
        this.hops = hops;
    }
    /**
     * Returns the SOAP response
     * 
     * @return Returns the response.
     */
    public String getResponse() {
        return response;
    }
    /**
     * Sets the SOAP response
     * 
     * @param response The response to set.
     */
    public void setResponse(String response) {
        this.response = response;
    }
        
    /**
     * Returns the MSD message
     * 
     * @return Returns the message.
     */
    public MSDMessage getMessage() {
        return message;
    }
    
    /**
     * Sets the MSD message
     * 
     * @param message The message to set.
     */
    public void setMessage(MSDMessage message) {
        this.message = message;
    }
   
}
