/*
 * Created on Jul 4, 2005
 *
 * Comments, questions: 
 *	Pierre-Guillaume.Raverdy@inria.fr
 *	Rafik.Chibout@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


package org.msda.components.manager.task;

import org.msda.components.manager.object.Object4Queue;

/**
 * Abstract class to define a task
 * 
 * @author agnes.de_la_chapelle@inria.fr - INRIA ARLES
 */
public abstract class TaskAbstract {

    /**
     * Terminates the task.
     */
    public abstract void terminate();
    
    /**
     * Runs the task.
     */
    public abstract void run();
    
    /**
     * Associates the Object4Queue with the task.
     *  
     * @param object
     */
    public abstract void setObject( Object4Queue object );
}
