/*
 * Created on Apr 19, 2005
 *
 * Comments, questions: 
 *	Pierre-Guillaume.Raverdy@inria.fr
 *	Rafik.Chibout@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


package org.msda.components.manager.task;

import org.msda.components.manager.MSDManagerPool;
import org.msda.components.manager.object.Object4Queue;
import org.msda.components.manager.object.ObjectRemoteRequest;

/**
 * Task that manages remote client requests.
 * 
 * @author raverdy, delachap - INRIA ARLES
 */
public class TaskRemoteRequest extends TaskAbstract {
    private MSDManagerPool managerPool;
    private ObjectRemoteRequest object;
    
    /**
     * TaskRemoteRequest. 
     * 
     * @param msdManagerPool
     */
    public TaskRemoteRequest( MSDManagerPool managerPool ) {
        this.managerPool = managerPool;
        this.object = null;
    }

    /**
     * @see org.msda.components.manager.task.TaskAbstract#setObject(org.msda.components.manager.Object4Queue)
     */
    public void setObject(Object4Queue object) {
        this.object = (ObjectRemoteRequest)object;
    }
    
    /**
     * @see org.msda.components.manager.task.TaskAbstract#terminate()
     */
    public void terminate() {
        this.managerPool = null;
        this.object = null;
    }
    
    /**
     * @see org.msda.components.manager.task.TaskAbstract#run()
     */
    public void run() {
        // 1- search with the plugin locally
        managerPool.evaluateRequest( object.getRequest(), true );
        // 2 - search in the cache of local description 
        managerPool.getDescManager().evaluateRequest( managerPool.getMSDManager(), managerPool.getBlockingQueue(), object.getRequest(), true, true );
        // 3 - search in the cache of remote descrition ?
        managerPool.getDescManager().evaluateRequest( managerPool.getMSDManager(), managerPool.getBlockingQueue(), object.getRequest(), false, true );
    }
}
