/*
 * Created on March 4, 2005
 *
 * Comments, questions: 
 *	Pierre-Guillaume.Raverdy@inria.fr
 *	Rafik.Chibout@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


package org.msda.components.plugins;



/*
*
* IFUtils.java
*
* @author Rafik CHIBOUT & Francoise SAILHAN
* @version 0.1 sept. 2004
*  
*/


import java.net.*;
import java.util.*;

public class IFUtils {

    
private static int countGetHost = 0;    
    
private native String[] getIFAddrs();
//private native void iwconfig2();
//private native int[] getACInfo();

    
private native int iproute(String gwIP);

public static int  VERSION_MAJOR    = 0;
public static int  VERSION_MINOR    = 1;
public static int  FLAGS            = 2;
public static int  ACLINE_STATUS    = 3;
public static int  BATTERY_STATUS   = 4;
public static int  BATTERY_FLAGS    = 5;
public static int  BATTERY_PERC     = 6;
public static int  BATTERY_TIME     = 7;
public static int  USING_MINUTES    = 8;

public static int  ADHOC            = 1;
public static int  INFRABASED       = 2;
public static int  INFRABASED_WIRED = 3;
    
private static boolean JavaNetNetworkInterfaceClass_Supported = true;
    
    static  {
        java.util.Properties props = System.getProperties();
        String osname = props.getProperty("os.name");

        if (osname.indexOf("Linux") != -1) {
            
            String sharedLibPath = null;
            if (System.getProperty("catalina.home") != null) 
                sharedLibPath = System.getProperty("catalina.home")+"/shared/lib";
            else if (System.getProperty("jetty.home") != null) 
                sharedLibPath = System.getProperty("jetty.home")+"/lib";
            //else sharedLibPath ="/local/chibout/work/Utils/lib";
            else sharedLibPath ="/opt/Ubisec-Service-Discovery/work/Utils/lib";

            String libIW = sharedLibPath+"/libiw.so.25"; 
            //System.load(libIW);                

            String libIW2 = sharedLibPath+"/libiw.so"; 
            //System.load(libIW2);                

            String libIFMgr = sharedLibPath+"/libifacemgr.so"; 
            //System.load(libIFMgr);
        } else if (osname.indexOf("Windows") != -1) {
            
            String sharedLibPath = null;
            if (System.getProperty("catalina.home") != null) 
                sharedLibPath = System.getProperty("catalina.home")+"\\shared\\lib";
            else if (System.getProperty("jetty.home") != null) 
                sharedLibPath = System.getProperty("jetty.home")+"\\lib\\classpath";
	    else sharedLibPath = "..\\lib";
            String libIFMgr = sharedLibPath+"\\ifacemgr.dll"; 
            //System.load(libIFMgr);
        }                
    }    
    
    
    public String[] getIFAddresses() {
        Vector addrVector = new Vector();
        String[] returnedValue = getIFAddrs();
        
        for (int i=0; i<returnedValue.length; i++)
            if (returnedValue[i] != null && !returnedValue[i].equals("127.0.0.1"))
                addrVector.add(returnedValue[i]);
        
        String[] addrArray = new String[addrVector.size()];
        addrVector.copyInto(addrArray);
        return addrArray;	
    }
    
    
    public String[] getLocalHostAddresses() {            
        Vector addrVector = new Vector();
                                
        try {
            if (JavaNetNetworkInterfaceClass_Supported) {
                for( Enumeration ifaces = NetworkInterface.getNetworkInterfaces(); ifaces!=null && ifaces.hasMoreElements(); ) {
                    NetworkInterface ni = (NetworkInterface) ifaces.nextElement();
                    for( Enumeration ips = ni.getInetAddresses(); ips.hasMoreElements(); ) {
                        InetAddress addr = (InetAddress) ips.nextElement();
                        if (!addr.isLoopbackAddress())
                            addrVector.add(addr.getHostAddress());
                    }
                }
            } else {
                try {
                    String[] returnedValue = getIFAddrs();
                    for (int i=0; i<returnedValue.length; i++)
                        if (returnedValue[i] != null && !returnedValue[i].equals("127.0.0.1"))
                            addrVector.add(returnedValue[i]);
                } catch (Exception ex2) {
                    ex2.printStackTrace();
                }                
            }
        } catch (NoClassDefFoundError ex) {
            //board.info("java.net.NetworkInteface class not supported");
            JavaNetNetworkInterfaceClass_Supported = false;
            
            try {
                String[] returnedValue = getIFAddrs();
                for (int i=0; i<returnedValue.length; i++)
                    if (returnedValue[i] != null && !returnedValue[i].equals("127.0.0.1"))
                        addrVector.add(returnedValue[i]);
            } catch (Exception ex2) {
                ex2.printStackTrace();
            }

        } catch (java.net.SocketException ex) {
            ex.printStackTrace();
            
            try {
                String hostname = java.net.InetAddress.getLocalHost().getHostAddress();
                addrVector.add(hostname);
            } catch (Exception ex2) {
                ex2.printStackTrace();
            }
 
        }
        
        String[] addrArray = new String[addrVector.size()];
        addrVector.copyInto(addrArray);
        return addrArray;	      
    }

}

