/*
 * Created on May 18, 2005
 *
 * Comments, questions: 
 *	Pierre-Guillaume.Raverdy@inria.fr
 *	Rafik.Chibout@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


 package org.msda.components.plugins;
 
 import java.net.HttpURLConnection;
 import java.net.URL;
 
 
 /**
  * @author rafik CHIBOUT
  */
 public class ServiceInvocation {
 	
 	public static String invokService(String sOAPMessage , String endPoint)
 	{
 		try {
 			
 			URL url = new java.net.URL(endPoint.toString());
 			java.net.HttpURLConnection urlConn = (java.net.HttpURLConnection)url.openConnection();
 			urlConn.setDoInput (true);
 			urlConn.setDoOutput (true);
 			urlConn.setUseCaches (false);
 			//			urlConn.setRequestProperty("User-Agent", "Profile/MIDP-1.0 Configuration/CLDC-1.0");
 			//			urlConn.setRequestProperty("Content-Language", "en-US");
 			//			urlConn.setRequestProperty("content-Type", "application/x-www-form-urlencoded");
 			
 			// required for Axis compatibility
 			// required for UPnP and Axis compatibility 
 			urlConn.setRequestProperty("content-Type", "text/html; charset="+'"'+"utf-8"+'"');
 			String serviceURL = url.getPath();
 			String serviceType = serviceURL.substring(serviceURL.lastIndexOf("/")+1);
 			
 			//sOAPMessage = sOAPMessage.toLowerCase();
 			//board.info("sOAPMessage:"+sOAPMessage);
 			int indexOfBodyStart = sOAPMessage.indexOf("Body>")+5;
 			int indexOfBodyEnd   = sOAPMessage.indexOf("Body>", indexOfBodyStart);
 			String sOAPBodyElement = sOAPMessage.substring(indexOfBodyStart, indexOfBodyEnd);
 			int index = sOAPBodyElement.indexOf("<");
 			String action = sOAPBodyElement.substring(index+1, sOAPBodyElement.indexOf(" ",index+1));
 			//String actionNsURI = null;
 			//String actionURI = null;
 			String actionName="";
 			if (action.indexOf(":") != -1) 
 			{
 				//actionNsURI = action.substring(0,action.indexOf(":")).trim();
 				
 				//find actionURI of this actionNsURI
 				//		    	   int nsIndex = sOAPMessage.indexOf("xmlns:"+actionNsURI+"=")+7+actionNsURI.length();
 				//		    	   if (nsIndex!=-1)
 				//		    	   {
 				//		    		   int index1 = sOAPMessage.indexOf(""+'"', nsIndex);
 				//		    		   int index2 = sOAPMessage.indexOf(""+'"',index1+1);
 				//		    		   if (index1 != -1 && index2 != -1) actionURI = sOAPMessage.substring(index1+1,index2);
 				//		    	   }
 				actionName = action.substring(action.indexOf(":")+1);
 			}
 			else actionName = action;
 			//action="";
 			
 			//		       if (actionURI !=null && !actionURI.equals(""))
 			//		    	   action  = (QName.valueOf("{"+actionURI+"}"+actionName)).toString();
 			//		       else action  = actionName;
 			
 			//board.info("serviceType="+serviceType);
 			//board.info("actionName="+actionName);
 			urlConn.setRequestProperty("SOAPACTION", "urn:schemas-upnp-org:service:"+serviceType+"#"+actionName);
 			
 			java.io.OutputStream os = urlConn.getOutputStream();
 			java.io.OutputStreamWriter writer = new  java.io.OutputStreamWriter(os);
 			
 			writer.write(sOAPMessage);
 			
 			writer.flush();
 			//writer.close();
 			//os.close();
 			while (urlConn.getResponseCode() != HttpURLConnection.HTTP_OK){}   
 			
 			java.io.InputStream is = urlConn.getInputStream();
 			java.io.InputStreamReader reader = new  java.io.InputStreamReader(is);
 			
 			StringBuffer sOAPResponse = new StringBuffer();
 			int num = 0;
 			
 			//board.info("I waiting for the first char");
 			
 			//while (!reader.ready()) { Thread.sleep(10);}
 			//board.info("I will get the response");
 			
 			while (num >=0 || reader.ready())
 			{
 				char[] buff = new char[1024];
 				num = reader.read(buff);
 				//board.info("Response read "+num+" chars");
 				if (num > 0) sOAPResponse.append(buff,0, num);
 			}
 			
 			//board.info("exit the read function");
 			writer.close();
 			os.close();
 			reader.close();
 			is.close();
 			urlConn.disconnect();
 			return sOAPResponse.toString();
 		}
 		catch (Exception ex) {
 			ex.printStackTrace();
 		}
 		return null;
 	}
 	
 	
 }
