/*
 * Created on Apr 1st, 2005
 *
 * Comments, questions: 
 *	Pierre-Guillaume.Raverdy@inria.fr
 *	Rafik.Chibout@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


package org.msda.components.plugins.msdaservice;

import org.msda.components.interfaces.MSDAServiceInterface;
import org.msda.components.interfaces.RequestInterface;
import org.msda.msd.MSDDescription;
import org.msda.msd.MSDRequest;
import org.msda.util.MSDException;


/**
 * Implementation of the MSDA service. 
 * This part is independant of the acual discovery or access protocol 
 * used to find and access the MSDA service.
 * 
 * @author rafik.chibout@inria.fr - INRIA ARLES
 */

public class MSDService implements MSDAServiceInterface
{
	RequestInterface msd = null;
	
	/**
	 * 
	 *
	 */
	public MSDService()
	{
		// to remove after adding to the msd core the getServices and getClientID functions
	}
	
	/**
	 * 
	 * @param msdInterface
	 * @throws MSDException
	 */
	public MSDService(RequestInterface msdInterface) throws MSDException
	{
		msd = msdInterface;
	}
	
	/**
	 * 
	 * @see org.msda.components.interfaces.MSDAServiceInterface#getServices(org.msda.msd.MSDRequest)
	 */
	public MSDDescription[] getServices(MSDRequest request)
	{
		// here invoke evaluteRequest method of MSD and return the result
		
		//	    board.info("");
		//		board.info("MSDService: MSDRequest is received");
		//		board.info("");
		//		board.info("request ="+request.getDescription());
		
		MSDDescription[] msdDescs = msd.getServices( request );
		//		if (msdDescs != null && msdDescs.length>0) 
		//			board.info("msdDescs Returned is "+msdDescs.length);
		//		else board.info("MSDDESCS returned is Empty");
		
		return msdDescs;
	}
	
	
	/**
	 * 
	 * @see org.msda.components.interfaces.MSDAServiceInterface#serviceAccess(java.lang.String, java.lang.String, java.lang.String)
	 */
	public String serviceAccess(String soapMessage, String descId, String epService)
	{
		// here invok serviceAccess method of MSD and return the result
		//		board.info("************************Service Access***************");
		//		board.info("EP SERVICE ="+epService);
		//		board.info("CLIENT ID ="+clientID);
		//		board.info("MSDService:soapMessage =");
		//		board.info(soapMessage);
		
		String soapResp = msd.serviceAccess( soapMessage, descId, epService );
		//		board.info("SOAPResponse= "+soapResp);
		//		board.info("*****************************************************");
		return soapResp;
	}
}

