package org.msda.context;

/**
 * @author Oriana Riva, INRIA - August 2005
 * 
 * Collection of parameters that characterize 
 * the context of a light control.
 *  
 * Document sources: Dimming V1.0 Template Version 1.0
 * for UPnP, November 23, 2003
 */

public class LightingControl_Dimming {

    /*
     * Private constructor to prevent instantiation.
     */
    private LightingControl_Dimming(){        
    }
    
    // List of profile parameters
    
    public static final String LOAD_LEVEL_TARGET = "LoadLevelTarget";
    // value of the desired load level
    
    public static final String LOAD_LEVEL_STATUS = "LoadLevelStatus";
    // current dimmer output level
    
    public static final String RAMP_RATE = "RampRate";
    // incremental level change per second
    
    public static final String RAMP_TIME = "RampTime";
    // time to reach the LoadLevelTarget
    
    
}
