package org.msda.context;

/**
 * @author Oriana Riva, INRIA - August 2005
 * 
 * Collection of parameters that characterize 
 * the context of a network
 * 
 */
public class NetworkTemplate {   

    /*
     * Private constructor to prevent instantiation.
     */
    private NetworkTemplate(){        
    }
    
    // network profile
    public static final String NETWORK_TYPE = "";
    // LAN, WLAN, PAN, Bluetooth, UMTS, GPRS, GSM, WAN, Ethernet, WiFi
    
    public static final String NETWORK_PROTOCOL ="";
    // IEEE802.11a, IEEE802.11b
    
    public static final String NETWORK_STATIC = "network_static";
    
    public static final String NETWORK_PUBLIC = "network_public";
    
    public static final String CREATION_TIME = "creation_time";
    
    public static final String EXPECTED_LIFETIME = "expected_lifetime";
    
    public static final String MIN_BANDWIDTH = "min_bandwidth";
    
    public static final String MAX_BANDWIDTH = "max_bandwidth";
    
    public static final String MAX_USERS = "max_users";
    
    public static final String COVERAGE = "coverage";
    
    public static final String AUTHENTICATION = "authentication";
    
    public static final String ENCRYPTION = "encryption";

    public static final String NUM_USERS = "numUsers";
    
    
    // network context    
    public static final String NUMBER_SERVICES = "number_services";
    
    public static final String NUMBER_USERS_ACTIVE = "number_users_active";
    
    public static final String NUMBER_SERVICES_ACTIVE = "number_services_active";
    
    public static final String SECURITY_LEVEL = "security_level";
    
    public static final String NETWORK_QUALITY = "network_quality";
    
    public static final String NETWORK_LOAD = "network_load";
    
    public static final String NETWORK_LATENCY = "network_latency"; 
    
    public static final String AVG_BANDWIDTH = "avg_bandwidth";
    
    //
    public static final String MAX_HOPS = "maxHops";
   
    public static final String HOP = "hop";
    
}
