package org.msda.context;

/**
 * @author Oriana Riva, INRIA - August 2005
 * 
 * Collection of parameters that characterize 
 * the context of a scanner.
 *  
 * Document sources: Scan:1.0 Service Template Version 1.01
 * for UPnP, September 11, 2002
 */

public class ScannerTemplate {

    /*
     * Private constructor to prevent instantiation.
     */
    private ScannerTemplate(){        
    }
    
    // List of profile parameters
    
    public static final String HEIGHT_LIMIT = "HeighLimit";    

    public static final String WIDTH_LIMIT = "WidthhLimit";    

    public static final String XValue_LIMIT = "XValueLimit";    

    public static final String YValue_LIMIT = "YValueLimit";
    
    
    // List of context parameters
    
    public static final String IMAGE_FORMAT = "ImageFormat";
    // format of the image to be returned
    // Example values are device-setting, jpeg, etc.
    
    public static final String COMPRESSION_FACTOR = "CompressionFactor";
    // compression for compressed image formats
    
    public static final String IMAGE_TYPE = "ImageType";
    // the type of image to be scanned
    // Example values are photo, text, graphics, mixed
    
    public static final String COLOR_TYPE = "ColorType";
    // Example values are color, mono, device-setting
    
    public static final String BIT_DEPTH = "BitDepth";
    // Example values are device-setting, 8, 12
    
    public static final String COLOR_SPACE = "ColorSpace";
    // Example values are device-setting, sRGB, YCC    
    
    public static final String SIDE_COUNT = "SideCount";
    // total number of sides remaining to be scanned in the current action
    
    public static final String SIDE_NUMBER = "SideNumber";
    // the side-number for the current scanning session
    
    public static final String RESOLUTION = "Resolution";
    // resolution of the image in pixels per inch
    
    public static final String SCNA_LENGTH = "ScanLength";
    // total lenght scanned, in milli-inches on the current page
    
    
    
}
