/*
 * Created on Aug 4, 2005
 * 
 * INRIA, ARLES Project
 * 
 * contact: Pierre-Guillaume.Raverdy@inria.fr<br>
 *          Rafik.Chibout@inria.fr
 * 
 * Copyright INRIA 2005
 */
package org.msda.context;

import org.msda.msd.ContextInformation;
import org.msda.msd.CreationInformation;
import org.msda.msd.MSDDescription;

/**
 * It contains all the context information characterizing a service
 * 
 * @author Oriana Riva, HIIT - 2005
 */
public class ServiceContext {
    
    private String serviceID;    
    private ContextInformation context_info;
    private CreationInformation creation_info;
    
    /**
     * Constructor
     * 
     * @param MSDservice
     */
    public ServiceContext(MSDDescription MSDservice){
        serviceID = MSDservice.getSvcDef().getGeneric().getName();
        //board.info("[ServiceContext]:  serviceID is " + serviceID);
        context_info = MSDservice.getCtxInfo();
        //board.info("[ServiceContext]:  context info is " + context_info);
        creation_info = MSDservice.getCreaInfo();
        //board.info("[ServiceContext]:  creation info is " + creation_info);
    }
    
    /**
     * to get the serviceID
     * 
     * @return String serviceID
     */
    public String getServiceID(){
        return serviceID;
    }
    
    /**
     * to get the contextinformation
     * 
     * @return ContextInformation 
     */
    public ContextInformation getContextInformation(){
        return context_info;
    }
    
    /**
     * to get the creation information
     * 
     * @return CreationInformation
     */
    public CreationInformation getCreationInformation(){
        return creation_info;
    }
    
    /**
     * to convert the service into a string
     * 
     * @return String
     */
    public String convertToString(){
        String s = "";
        s = "serviceID: " + serviceID + "/n";
//        s = s + "JobID: " + this.context_info.getJobID() + "/n";
//        s = s + "ServiceState: " + this.context_info.getServiceState() + "/n";
//        s = s + "JobName: " + this.context_info.getJobName() + "/n";
        s = s + "Creator: " + this.creation_info.getCreator().toString() + "/n";
        s = s + "CreationTime: " + this.creation_info.getCreaTime().toString();
        return s;
    }

}
