/*
 * Created on 27 mai 2005
 *
 * INRIA - ARLES Project
 * 
 * contact: Pierre-Guillaume.Raverdy@inria.fr
 * Preliminary version, please do not distribute
 * 
 * Copyright 2005
 */

package org.msda.context;

import java.io.*;

/**
 * 
 * @author 
 */
public class SystemInfo
{

	/**
	 * 
	 * @return
	 */
    public static int getEnergy()
    {
	try
	    {
		File energyFile = new File("/proc/apm");
		if (energyFile.exists())
		    {
			FileReader energyFileReader = new FileReader(energyFile);
			BufferedReader energyReader = new BufferedReader(energyFileReader);
			boolean bool= true;
			String energyLine = energyReader.readLine();
			while (energyLine !=null && bool)
			    {
				if (!energyLine.equals(""))
				    {
					bool = false;
					int index1 = energyLine.indexOf("%");
					if (index1 !=-1)
					    {
						energyLine = energyLine.substring(0,index1);
						int index0 = energyLine.lastIndexOf(" ");
						if (index0 !=-1)
						    {
							String energyCapacity = energyLine.substring(index0+1,index1);
							energyFileReader.close();
							return (new Integer(energyCapacity)).intValue();
						    }
					    } 
				    }
				energyLine = energyReader.readLine();
			    }
			energyFileReader.close();
			return -1; // System energy File not conforme with our algorithm  
		    }
		else return 101; // the node is wired station
	    }
	catch (Exception ex)
	    {
		return -1;
	    }
    }
	
    /**
     * 
     * @return
     */
    public static int getTotalMemory()
    {
       	try
	    {                               
		File memoryFile = new File("/proc/meminfo");
		if (memoryFile.exists())
		    {
			FileReader memoryFileReader = new FileReader(memoryFile);
			BufferedReader memoryReader = new BufferedReader(memoryFileReader);
			String tmp = memoryReader.readLine();
			while (memoryReader.ready())
			    {
				String memoryLine = memoryReader.readLine();
				memoryLine = memoryLine.toLowerCase();
				if (memoryLine !=null && !memoryLine.equals("") && memoryLine.startsWith("memtotal:"))
				    {
					int index0 = 10;
					int index1 = memoryLine.indexOf("kb");
					if (index1!=-1)
					    {
						String memorySize = memoryLine.substring(index0,index1);
						memorySize = memorySize.trim();
						return (new Integer(memorySize)).intValue();
					    }
					else return -1;
				    }
			    }
			return -1; // System memory File not conforme with our SystemInfo   
		    }
		else return -1; // Operating System not conforme with our SystemInfo 
	    }
	catch (Exception ex)
	    {
		return -1;
	    }
    }

    /**
     * 
     * @return
     */
    public static int getFreeMemory()
    {
	try
	    {                               
		File memoryFile = new File("/proc/meminfo");
		if (memoryFile.exists())
		    {
			FileReader memoryFileReader = new FileReader(memoryFile);
			BufferedReader memoryReader = new BufferedReader(memoryFileReader);
			String tmp = memoryReader.readLine();
			while (memoryReader.ready())
			    {
				String memoryLine = memoryReader.readLine();
				memoryLine = memoryLine.toLowerCase();
				if (memoryLine !=null && !memoryLine.equals("") && memoryLine.startsWith("memfree:"))
				    {
					int index0 = 10;
					int index1 = memoryLine.indexOf("kb");
					if (index1!=-1)
					    {
						String memorySize = memoryLine.substring(index0,index1);
						memorySize = memorySize.trim();
						return (new Integer(memorySize)).intValue();
					    }
					else return -1;
				    }
			    }
			return -1; // System memory File not conforme with our SystemInfo   
		    }
		else return -1; // Operating System not conforme with our SystemInfo 
	    }
	catch (Exception ex)
	    {
		return -1;
	    }
    }

    /**
     * 
     * @return
     */
    public static int getCPUCapacity()
    {
	try
	    {                               
		File cpuFile = new File("/proc/cpuinfo");
		if (cpuFile.exists())
		    {
			FileReader cpuFileReader = new FileReader(cpuFile);
			BufferedReader cpuReader = new BufferedReader(cpuFileReader);
			String tmp = cpuReader.readLine();
			while (cpuReader.ready())
			    {
				String cpuLine = cpuReader.readLine();
				cpuLine = cpuLine.toLowerCase();
				if (cpuLine !=null && !cpuLine.equals("") && (cpuLine.startsWith("cpu mhz") || cpuLine.startsWith("bogomips") ))
				    {
					int index0 = cpuLine.indexOf(":");
					if (index0!=-1)
					    {
						String cpuCapacity = cpuLine.substring(index0+1);
						cpuCapacity = cpuCapacity.trim();
						return (new Float(cpuCapacity)).intValue();
					    }
					else return -1;
				    }
			    }
			return -1; // System cpu File not conforme with our SystemInfo   
		    }
		else return -1; // Operating System not conforme with our SystemInfo 
	    }
	catch (Exception ex)
	    {
		return -1;
	    }
    }

    /**
     * 
     * @return
     */
    public static int getCacheSize()
    {
	try
	    {                               
		File cpuFile = new File("/proc/cpuinfo");
		if (cpuFile.exists())
		    {
			FileReader cpuFileReader = new FileReader(cpuFile);
			BufferedReader cpuReader = new BufferedReader(cpuFileReader);
			String tmp = cpuReader.readLine();
			while (cpuReader.ready())
			    {
				String cpuLine = cpuReader.readLine();
				cpuLine = cpuLine.toLowerCase();
				if (cpuLine !=null && !cpuLine.equals("") && cpuLine.startsWith("cache size"))
				    {
					int index0 = cpuLine.indexOf(":");
					if (index0!=-1)
					    {
						int index1 = cpuLine.indexOf("kb");
						if (index1!=-1) 
						    {
							String cpuCache = cpuLine.substring(index0+1,index1);
							cpuCache = cpuCache.trim();
							return (new Integer(cpuCache)).intValue();
						    }
						else return -1;
					    }
					else return -1;
				    }
			    }
			return -1; // System cpu File not conforme with our SystemInfo   
		    }
		else return -1; // Operating System not conforme with our SystemInfo 
	    }
	catch (Exception ex)
	    {
		return -1;
	    }
	
    }

}
