/*
 * Created on Dec 13, 2005
 *
 * Comments, questions: 
 *	Pierre-Guillaume.Raverdy@inria.fr
 *	Rafik.Chibout@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


package org.msda.gui;


import java.io.IOException;
import java.text.FieldPosition;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import org.msda.gui.*;
import org.msda.msd.*;


/*
 * @author raverdy
 */

public class FrameworkGUI implements GUIMessageNotification, GUINotification {
    private ManagerGUI guiManager;
    private BridgeGUI guiBridge;

    /**
     * 
     *
     */
    public FrameworkGUI ()
	{
    }
    
    /**
     * Sets the manager GUI.
     * 
     * @param gui The gui to set.
     */
    public void setGuiManager(ManagerGUI gui) {
        this.guiManager = gui;
    }
    
    /**
     * Sets the bridge GUI.
     * 
     * @param gui The gui to set.
     */
    public void setGuiBridge(BridgeGUI gui) {
        this.guiBridge = gui;
    }

    // 
    // Needed for the GUI
    //
    
    public void notify( Object o ) {
        
        if ( this.guiManager!=null ) {
            
            StringBuffer buf = new StringBuffer();
            buf = buf.append( o ).append( System.getProperty("line.separator") )
            					 .append( System.getProperty("line.separator") );
            
            this.guiManager.notify( buf.toString() );
        }
        
        if ( this.guiBridge!=null ) {
            
            StringBuffer buf = new StringBuffer();
            buf = buf.append( o ).append( System.getProperty("line.separator") )
            					 .append( System.getProperty("line.separator") );
            
            this.guiBridge.notify( buf.toString() );
        }
    }
    
    public void notify( Object o, String from ) {
        
 //       if ( log.isDebugEnabled() ) {
 //           log.debug( o );
  //      }
        
        if ( this.guiManager!=null ) {
            this.guiManager.notify( o, from );
        }
    }

    // GUI Notification
    
    public void addBridge() {
        if ( this.guiManager!=null )
            this.guiManager.addBridge();
    }
    
    public void addManager() {
        if ( this.guiBridge!=null )
            this.guiBridge.addManager();
    }

    public void removeBridge(String name) {
        if ( this.guiManager!=null )
            this.guiManager.removeBridge(name);
    }

    public void removeManager(String name) {
        if ( this.guiBridge!=null )
            this.guiBridge.removeManager(name);
    }


    /**
     * @see org.msda.gui.GUINotification#addDescription(boolean)
     */
    public void addDescription(boolean local) {
        // TODO Auto-generated method stub

    }
    /**
     * @see org.msda.gui.GUINotification#removeDescription(boolean)
     */
    public void removeDescription(boolean local) {
        // TODO Auto-generated method stub

    }

}
