/*
 * Created on May 16, 2005
 *
 * Comments, questions: 
 *	Pierre-Guillaume.Raverdy@inria.fr
 *	Rafik.Chibout@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


package org.msda.gui;

/**
 * @author agnes.de_la_chapelle@inria.fr - INRIA ARLES
 *
 */
public interface GUINotification {

    /**
     * Notify the GUI that a description has been added.
     * 
     * @param local true if the description is a local description, false otherwise
     */
    public void addDescription( boolean local );
    
    /**
     * Notify the GUI that a description has been removed.
     * 
     * @param local	true if the description is a remote description, false otherwise
     */
    public void removeDescription( boolean local );
    
    
    public void addBridge();
    
    public void addManager();

    public void removeBridge(String name);
    
    public void removeManager(String name);
}
