/*
 * Created on Aug 9, 2004
 *
 * @author raverdy
 * Comments, questions: Pierre-Guillaume.Raverdy@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 


package org.msda.util.comm;

import org.msda.msd.*;

/**
 * This interface contains all the methods that must be implemented by the msd network component
 * to communicate with other msd network components over the msd multicast group, and to receive 
 * specific message from them (requests, descriptions, ...).
 * 
 * @author pgr
 *
 */
public interface MulticastGroupCallback {  

	/**
	 * The MSDMessage holds a response for a discoveryRequest
	 * @param message the msd message received on the multicast group
	 */
	public void receivedMessage ( MSDMessage message );
}
