/*
 * Created on Dec 13, 2005
 * 
 * @author raverdy
 * Comments, questions: Pierre-Guillaume.Raverdy@inria.fr
 *
 * INRIA, ARLES Project
 * 2004-2005
 */ 

package org.msda.util.comm;

import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.Enumeration;

/*
 * @author raverdy
 */
public class NetworkUtils {
	/**
	 * Returns the IP address corresponding to the network interface name
	 * 
	 * @param ifname	The network interface name
	 * @return	IP address
	 */
	static public String getIPAddress ( String ifname )
	{
		NetworkInterface netinterface;
		Enumeration ints;
		InetAddress addr;
		
		try {
			netinterface = NetworkInterface.getByName(ifname);
			ints = netinterface.getInetAddresses();
			while( ints.hasMoreElements() )
			{
				addr = (InetAddress)ints.nextElement();
				if (!addr.isLoopbackAddress() )
				{
					return addr.getHostAddress();
				}
			}
		}
		catch (SocketException  e) {		    
			e.printStackTrace();
			return null;
		}
		return null;
	}

}
