/*
 * Created on July 19, 2005
 *
 * INRIA, ARLES Project
 * 
 * contact: Pierre-Guillaume.Raverdy@inria.fr<br>
 *          Rafik.Chibout@inria.fr
 * 
 * Copyright INRIA 2005
 */
package org.msda.clientsamples.ariadne;




import org.msda.MSDClientAPIService.MSDClientAPIBindingStub;
import org.msda.msd.*;
import org.msda.msd.impl.*;
import org.msda.plugins.ariadne.SDService.SDBindingStub;
import org.msda.plugins.ariadne.SDService.SDPortType;


import ubisec.util.system.IFUtils;

import java.util.*;

/**
 * @author rafik CHIBOUT
 */

public class clientAriadne {
	
public void callService()
{
	// find URL Of MSDService
	String ctrUrl = "";
	
	try
	{
		String dataStr = "";
		IFUtils ifUtils = new IFUtils();
		String localIPAddress = ifUtils.getLocalHostAddresses()[0];
		SDPortType sd = new SDBindingStub("http://"+localIPAddress+":8080/services/SD");
		
		//sd.start();
		//while (!sd.isStarted()) {}
		
		try
		    {
			java.io.FileInputStream wsdlMSDService = new java.io.FileInputStream("configuration/MSDServiceInterface.wsdl");
						
			while (wsdlMSDService.available() >0)
			    {
					byte[] data = new byte[wsdlMSDService.available()];
					wsdlMSDService.read(data);
					dataStr = dataStr+(new String(data));
			    }
			
		    }
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		
		org.msda.plugins.ariadne.SDService.GetServiceData[] foundServices = sd.getServices(dataStr);
		if (foundServices != null && foundServices.length >0)
			ctrUrl = foundServices[0].getServiceEP(); 
		System.out.println("ctrlUrl="+ctrUrl);
	}
	catch(Exception ex)
	{
		ex.printStackTrace();
	}
	
	
	org.msda.MSDClientAPIService.MSDClientAPIPortType service = new MSDClientAPIBindingStub(ctrUrl);
	//MSDClientAPIService.MSDClientAPIPortType service = new MSDClientAPIBindingStub("http://128.93.9.15:8080/discovery/serviceaccess");
	
	MSDRequestImpl msdRequest = new MSDRequestImpl();
	ReqDescriptionInformation reqDescription = new ReqDescriptionInformationImpl();
	
	RequestService requestService = new RequestServiceImpl();
	//requestService.setName("uuid:0000E8699FB4:urn:schemas-upnp-org:service:service1:1:0");
	//requestService.setName("urn:schemas-upnp-org:service:service1:1:0");
	//requestService.setName("uuid:0000E8699FB4:service1");
	requestService.setName("urn:MovieService");
	// Required Methods 
    List methods = requestService.getMethods();
//    ///Method method = new MethodImpl();
//    method.setName("getService");
//    List paramIn  = method.getInputs();
//    List paramOut = method.getOutputs();
//    
//    Param param1 = new ParamImpl();
//    param1.setName("name");
//    
//    Param param2 = new ParamImpl();
//    param2.setName("return");
//    
//    paramIn.add(param1);
//    paramOut.add(param2);
//    
//    methods.add(method);
//        
//    Method method2 = new MethodImpl();
//    method2.setName("getName");
//    
//    List paramOut2 = method2.getOutputs();
//    	    	    
//    Param param22 = new ParamImpl();
//    param22.setName("return");
//    
//    paramOut2.add(param22);
//    
//    methods.add(method2);
    
	reqDescription.setService(requestService);
    msdRequest.setDescInfo(reqDescription);
    
    try
	{
    MSDDescriptionImpl[] msdDescs = service.getServices(msdRequest);
    System.out.println("service invoked");
    if (msdDescs != null)
    {
    	if (msdDescs.length>0)
    	{
    		MSDDescriptionImpl desc = msdDescs[0];
    		methods = desc.getSvcDef().getGeneric().getMethods();
			for (int d=0; d<methods.size();d++)
			{
				Method method = (Method)methods.get(d);
				System.out.println("msdService methodName="+method.getName());
				List paramIn = method.getIn();
				List paramOut = method.getOut();
				
				for (int k=0; k<paramIn.size(); k++)
				{	
					Param param = (Param)paramIn.get(k);
					System.out.println("msdService in Param"+param.getType());
				}
		
				for (int u= 0 ;u<paramOut.size(); u++)
				{
					Param param = (Param)paramOut.get(u);
					System.out.println("msdService out Param"+param.getType());
				}
			}
			System.out.println("*******************************");
    		
			
			// getClient ID function
//			int id = service.getClientID(desc);
//			System.out.println("id = "+id);

    	}
    	else System.out.println("the result is Empty");
    }
    else System.out.println("the result is null");
	}
    catch(Exception ex)
	{
    	ex.printStackTrace();
	}
}

	public static void main(String[] args) {
		
		clientAriadne app = new clientAriadne();
		app.callService();
	}
}
