/*
 * Created on June 13, 2005
 *
 * INRIA, ARLES Project
 * 
 * contact: Pierre-Guillaume.Raverdy@inria.fr<br>
 *          Rafik.Chibout@inria.fr
 * 
 * Copyright INRIA 2005
 */
package org.msda.clientsamples.pdp.rfid;

import java.awt.Button;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.List;
import java.awt.Panel;
import java.awt.ScrollPane;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;



/**
 * @author Rafik CHIBOUT
 *
 */
public class AccessPanel extends Panel {

    private static final String BUTTON1 = "Get infos";
    private static final String BUTTON2 = "Get Pictures";
    
    private Button button1;
    private Button button2; 
    
    private ScrollPane scroll;
    private List list;
    private ClientRFID client;
    
    
    public AccessPanel( ClientRFID client  ) {
     
        setSize( ClientRFID.WIDTH, 200 );
        
        this.client = client;
        
        list = new List();
        
        scroll = new ScrollPane();
        scroll.add( list );
        scroll.setSize( ClientRFID.WIDTH-20, 120 );
        
        ActionListener buttonListener = new ButtonActionListener();
        
        button1 = new Button( BUTTON1 );
        button1.setEnabled( false );
        button1.addActionListener( buttonListener );
        
        button2 = new Button( BUTTON2 );
        button2.setEnabled( false );
        button2.addActionListener( buttonListener );
        
        Panel buttonsPanel = new Panel();
        buttonsPanel.add( button1 );
        buttonsPanel.add( button2 );
        
        
        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints( scroll, c);
        
        c.fill = GridBagConstraints.BOTH;
        gridbag.setConstraints( buttonsPanel, c);
        
        setLayout(gridbag);
        
        add( scroll );
        add( buttonsPanel );
    }
    
    public void setEnabled( boolean enable ) {
        
        button1.setEnabled( enable );
        button2.setEnabled( enable );
    }
    
    private void action1() {
        
        System.out.println(" Button1 pressed  ");
        
        // call the service access
        
        Vector v = new Vector();
        v.add("coucou 1");
        v.add("coucou 2");
        v.add("coucou 3");
        v.add("coucou 4");
        v.add("coucou 5");
        
        list = new List();
        for ( int i=0; i<v.size() ;i++) {
            list.add( (String)v.get(i) );
        }
        
        scroll.remove( 0 );
        scroll.add( list );
        this.getParent().paintAll( this.getParent().getGraphics() );
    }
    
    private void action2() {
        System.out.println(" Button2 pressed  ");
        
        Vector v = new Vector();
        v.add("pfff 1");
        v.add("pfff 2");
        v.add("pfff 3");
        v.add("pfff 4");
        
        list = new List();
        for ( int i=0; i<v.size() ;i++) {
            list.add( (String)v.get(i) );
        }
        
        scroll.remove( 0 );
        scroll.add( list );
        
        this.getParent().paintAll( this.getParent().getGraphics() );
    }
    
    class ButtonActionListener implements ActionListener  {
      
      public void actionPerformed(ActionEvent ae) {
          
          String action = ae.getActionCommand();
          
          if ( BUTTON1.equals( action ) ) {
              action1();
              
          } else if ( BUTTON2.equals( action ) ) {
              action2();
          } 
      }
    }
}
