/*
 * Created on June 13, 2005
 *
 * INRIA, ARLES Project
 * 
 * contact: Pierre-Guillaume.Raverdy@inria.fr<br>
 *          Rafik.Chibout@inria.fr
 * 
 * Copyright INRIA 2005
 */
package org.msda.clientsamples.pdp.rfid;

import java.awt.Button;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * @author Rafik CHIBOUT
 *
 */
public class SearchPanel extends Panel {

    private static final String BUTTON1 = "Check PDP";
    private static final String BUTTON2 = "Check MSD"; 
    
    private Label label;
    private TextField textNumber; 
    
    private Button button1;
    private Button button2;
    
    private ClientRFID client ;
    
    public SearchPanel( ClientRFID client ) {
        
        setSize( ClientRFID.WIDTH, 100 );
        
        this.client = client;
        
        label = new Label( "RFID number ");
        textNumber = new TextField( 12 );
        
        Panel tmpPanel = new Panel();
        tmpPanel.add( label );
        tmpPanel.add( textNumber );
        
        initButton();
        
        Panel buttonsPanel = new Panel();
        buttonsPanel.add( button1 );
        buttonsPanel.add( button2 );
        
//      add to the panel
        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
        c.gridwidth = GridBagConstraints.REMAINDER;
        c.fill = GridBagConstraints.HORIZONTAL;
        gridbag.setConstraints( tmpPanel, c);
        
        c.fill = GridBagConstraints.BOTH;
        gridbag.setConstraints( buttonsPanel, c);
        
        setLayout(gridbag);
        
        add( tmpPanel );
        add( buttonsPanel );
    }
    
    
    private void initButton() {
        
        ActionListener buttonListener = new ButtonActionListener();
        
        button1 = new Button( BUTTON1 );
        button1.addActionListener( buttonListener );
        
        button2 = new Button( BUTTON2 );
        button2.addActionListener( buttonListener );
    }
    
    private void action1() {
        System.out.println(" Button1 pressed with "+textNumber.getText().trim());
        client.findPDPService();
        client.getAccessPanel().setEnabled(true);
    }
    
    private void action2() {
        System.out.println(" Button2 pressed with "+textNumber.getText().trim());
        client.findService();
        client.getAccessPanel().setEnabled(true);
    }
    
    class ButtonActionListener implements ActionListener  {
      
      public void actionPerformed(ActionEvent ae) {
          
          String action = ae.getActionCommand();
          
          if ( BUTTON1.equals( action ) ) {
              action1();
              
          } else if ( BUTTON2.equals( action ) ) {
              action2();
          } 
      }
  }
}
