/*
 * Created on June 13, 2005
 *
 * INRIA, ARLES Project
 * 
 * contact: Pierre-Guillaume.Raverdy@inria.fr<br>
 *          Rafik.Chibout@inria.fr
 * 
 * Copyright INRIA 2005
 */
package org.msda.clientsamples.slp;




import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;
import org.msda.MSDClientAPIService.MSDClientAPIBindingStub;
import org.msda.msd.*;
import org.msda.msd.impl.*;

import com.solers.slp.Locator;
import com.solers.slp.ServiceLocationEnumeration;
import com.solers.slp.ServiceLocationManager;
import com.solers.slp.ServiceType;
import com.solers.slp.ServiceURL;



import java.util.*;

/**
 * @author rafik CHIBOUT
 */

public class clientSLP {
    
    final static Logger logger = Logger.getLogger(clientSLP.class);
    
    public void callService()
    {
        // find URL Of MSDService
        
        BasicConfigurator.configure();
        String ctrUrl = "";
        
        try
        {
            Locator locator = ServiceLocationManager.getLocator(Locale.FRANCE);
            ServiceType serviceType = new ServiceType("service:msdservice");
            Vector scopes = new Vector(); 
            scopes.add("default");
            
            ServiceLocationEnumeration foundServices = locator.findServices(serviceType, scopes, "");
            if (foundServices !=null)
                if (foundServices.hasMoreElements())
                {
                    ServiceURL foundService = (ServiceURL)foundServices.next();
                    ctrUrl = "http://"+foundService.getHost()+":"+foundService.getPort()+foundService.getURLPath();
                    System.out.println("clientSLP: MSDService URL="+ctrUrl);
                }
                
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
        
        
        org.msda.MSDClientAPIService.MSDClientAPIPortType service = new MSDClientAPIBindingStub(ctrUrl);
        //MSDClientAPIService.MSDClientAPIPortType service = new MSDClientAPIBindingStub("http://128.93.9.15:8080/discovery/serviceaccess");
        
        MSDRequestImpl msdRequest = new MSDRequestImpl();
        ReqDescriptionInformation reqDescription = new ReqDescriptionInformationImpl();
        
        RequestService requestService = new RequestServiceImpl();
        //requestService.setName("uuid:0000E8699FB4:urn:schemas-upnp-org:service:service1:1:0");
        //requestService.setName("urn:schemas-upnp-org:service:service1:1:0");
        //requestService.setName("uuid:0000E8699FB4:service1");
        requestService.setName("service1");
        // Required Methods 
        List methods = requestService.getMethods();
        Method method = new MethodImpl();
        method.setName("setName");
        List paramIn  = method.getIn();
        List paramOut = method.getOut();
        
        Param param1 = new ParamImpl();
        param1.setType("name");
        
        Param param2 = new ParamImpl();
        param2.setType("return");
        
        paramIn.add(param1);
        paramOut.add(param2);
        
        methods.add(method);
        
        Method method2 = new MethodImpl();
        method2.setName("getName");
        
        List paramOut2 = method2.getOut();
        
        Param param22 = new ParamImpl();
        param22.setType("return");
        
        paramOut2.add(param22);
        
        methods.add(method2);
        
        reqDescription.setService(requestService);
        msdRequest.setDescInfo(reqDescription);
        
        try
        {
            MSDDescriptionImpl[] msdDescs = service.getServices(msdRequest);
            System.out.println("service invoked");
            if (msdDescs != null)
            {
                if (msdDescs.length>0)
                {
                    MSDDescriptionImpl desc = msdDescs[0];
                    methods = desc.getSvcDef().getGeneric().getMethods();
                    for (int d=0; d<methods.size();d++)
                    {
                        method = (Method)methods.get(d);
                        System.out.println("msdService methodName="+method.getName());
                        paramIn = method.getIn();
                        paramOut = method.getOut();
                        
                        for (int k=0; k<paramIn.size(); k++)
                        {	
                            Param param = (Param)paramIn.get(k);
                            System.out.println("msdService in Param"+param.getType());
                        }
                        
                        for (int u= 0 ;u<paramOut.size(); u++)
                        {
                            Param param = (Param)paramOut.get(u);
                            System.out.println("msdService out Param"+param.getType());
                        }
                    }
                    System.out.println("*******************************");
                    
                    
                    // getClient ID function
//                    int id = service.getClientID(desc);
//                    System.out.println("id = "+id);
                    
                }
                else System.out.println("the result is Empty");
            }
            else System.out.println("the result is null");
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
    }
    
    public static void main(String[] args) {
        
        clientSLP app = new clientSLP();
        app.callService();
    }
}
