/*
 * Created on June 13, 2005
 *
 * INRIA, ARLES Project
 * 
 * contact: Pierre-Guillaume.Raverdy@inria.fr<br>
 *          Rafik.Chibout@inria.fr
 * 
 * Copyright INRIA 2005
 */
package org.msda.clientsamples.slp.rfid;

import java.awt.Button;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Label;
import java.awt.List;
import java.awt.Panel;
import java.awt.ScrollPane;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JOptionPane;

/**
 * Class that creates the access panel.
 *
 * @author agnes.de_la_chapelle@inria.fr - INRIA ARLES
 */
public class AccessPanel extends Panel {
    
    private static final String BUTTON1 = "Get infos";
    private static final String BUTTON2 = "Get Pictures";
    private static final String BUTTON_BACK = "Back"; 
    
    private Button button1;
    private Button button2; 
    private Button buttonBack;
    
    private Label label;
    private TextField textNumber; 
    
    private ScrollPane scroll;
    private List list;
    private ClientGUI client;
    
    
    public AccessPanel( ClientGUI client  ) {
        
        setSize( ClientGUI.WIDTH, 200 );
        
        this.client = client;
        
        label = new Label( "# RFID" );
        textNumber = new TextField( "4-010165-314153" );
        
        Label label2 = new Label( "       " );
        
        ActionListener buttonListener = new ButtonActionListener();
        
        buttonBack = new Button( BUTTON_BACK );
        buttonBack.addActionListener( buttonListener );
        
        button1 = new Button( BUTTON1 );
        button1.addActionListener( buttonListener );
        
        button2 = new Button( BUTTON2 );
        button2.addActionListener( buttonListener );
        
        Panel tmpPanel = new Panel();
        tmpPanel.add( buttonBack );
        tmpPanel.add( label2 );
        tmpPanel.add( label );
        tmpPanel.add( textNumber );
        
        list = new List();
        
        scroll = new ScrollPane();
        scroll.add( list );
        scroll.setSize( ClientGUI.WIDTH-20, ClientGUI.HEIGHT-100 );
        
        
        
        Panel buttonsPanel = new Panel();
        buttonsPanel.add( button1 );
        // buttonsPanel.add( button2 );
        
        
        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints( tmpPanel, c);
        
        gridbag.setConstraints( buttonsPanel, c);
        
        c.fill = GridBagConstraints.BOTH;
        gridbag.setConstraints( scroll, c);
        
        setLayout(gridbag);
        
        add( tmpPanel );
        add( buttonsPanel );
        add( scroll );
    }
    
    
    public void cleanList() {
        list = new List();
        scroll.remove( 0 );
        scroll.add( list );
        this.getParent().paintAll( this.getParent().getGraphics() );
    }
    
    private void action1() {
        
        list = new List();
        scroll.remove( 0 );
        scroll.add( list );
        this.getParent().paintAll( this.getParent().getGraphics() );
        
        
        // call the service access
        
        Vector v = new Vector();
        
        try
        {
            String chain ="";
            //            if (client.getSearchPanel().getSearchType() == 1)
            //            {
            //               chain = client.upnpRFIDAccess(textNumber.getText().trim());	
            //            }
            //            else 
            if (client.getSearchPanel().getSearchType() == 2)
            {
                //System.out.println("AGNES getInfo 1="+textNumber.getText().trim());
                chain = client.getClient().getRfidService().getInfo(textNumber.getText().trim());
                //System.out.println("AGNES getInfo 2="+chain);
            }
            
            if (chain != null && !chain.equals(""))
            {
                int indexOfSpeCar = 0;
                int indexOfSpeCar2 = 0;
                while (indexOfSpeCar != -1)
                {
                    indexOfSpeCar2 = chain.indexOf("#", indexOfSpeCar);
                    if ( indexOfSpeCar2 < 0 )
                        break;
                    v.add(chain.substring(indexOfSpeCar, indexOfSpeCar2));
                    indexOfSpeCar = chain.indexOf("#", indexOfSpeCar)+1;
                }
            }
            
            if ( chain != null && chain.equals("") ) {
                JOptionPane.showMessageDialog(this,"There is no results.","Search result",JOptionPane.INFORMATION_MESSAGE);
            }
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
        
        list = new List();
        for ( int i=0; i<v.size() ;i++) {
            list.add( (String)v.get(i) );
        }
        
        scroll.remove( 0 );
        scroll.add( list );
        this.getParent().paintAll( this.getParent().getGraphics() );
    }
    
    private void action2() {
        
        Vector v = new Vector();
        v.add("pfff 1");
        v.add("pfff 2");
        v.add("pfff 3");
        v.add("pfff 4");
        
        list = new List();
        for ( int i=0; i<v.size() ;i++) {
            list.add( (String)v.get(i) );
        }
        
        scroll.remove( 0 );
        scroll.add( list );
        
        this.getParent().paintAll( this.getParent().getGraphics() );
    }
    
    private void actionBack() {
        client.back();
    }
    
    class ButtonActionListener implements ActionListener  {
        
        public void actionPerformed(ActionEvent ae) {
            
            String action = ae.getActionCommand();
            
            if ( BUTTON1.equals( action ) ) {
                action1();
                
            } else if ( BUTTON2.equals( action ) ) {
                action2();
            } else if ( BUTTON_BACK.equals( action ) ) {
                actionBack();
            } 
        }
    }
}