/*
 * Created on April 18, 2005
 *
 * INRIA, ARLES Project
 * 
 * contact: Pierre-Guillaume.Raverdy@inria.fr<br>
 *          Rafik.Chibout@inria.fr
 * 
 * Copyright INRIA 2005
 */
package org.msda.clientsamples.upnp;



import org.msda.MSDClientAPIService.MSDClientAPIBindingStub;
import org.msda.msd.*;
import org.msda.msd.impl.*;




import com.siemens.upnp.UPnPConstants;
import com.siemens.upnp.controlpoint.ControlPoint;

import com.siemens.upnp.controlpoint.ProxyDevice;
import com.siemens.upnp.controlpoint.ProxyService;
import com.siemens.upnp.controlpoint.UPnPSearchResponseListener;


import java.io.BufferedInputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.*;

/**
 * @author rafik CHIBOUT
 */

public class clientUPnP {
	
public void callService()
{
	// find URL Of MSDService
	
	// init the CP
	ControlPoint controlPoint = ControlPoint.getInstance();
	DeviceDesc deviceDesc = new DeviceDesc();
	UPnPSearchResponseListener searchResponseListener = new UPnPSearchResponseListenerImpl(deviceDesc);
	controlPoint.addUPnPSearchListener(searchResponseListener);
	
	// search MSDService
	
	String ctrUrl = "";
	
	try
	{

	controlPoint.search(UPnPConstants.SearchForServiceType("msdservice:1:0"));
	while (deviceDesc.getDescriptionURL() == null ) {}
	System.out.println("DescrURL = "+deviceDesc.getDescriptionURL());
	URL url = new URL(deviceDesc.getDescriptionURL());
		// show the Description
		
		HttpURLConnection conn = (HttpURLConnection)url.openConnection();
		BufferedInputStream reader = new BufferedInputStream(conn.getInputStream());
		byte	[] buff = new byte[1000];
		while (reader.available()>0)
		{
			int num= reader.read(buff,0,buff.length);
			System.out.print(new String(buff,0,num));
		}
		System.out.println("");
		System.out.println("**************");
		
		System.out.println("Level 1");
		ProxyDevice device = controlPoint.createDevice(url);
	
		
		System.out.println("Level 2: Device created");
		java.util.Vector services = device.getServices();
		
		//ProxyService service = device.getServiceByID("service1");
		//ProxyService service = device.getServiceByType("service1");
		System.out.println("Level 3: service proxy get");
		if (services != null && services.size()>0)
		{
			ProxyService service = (ProxyService)services.elementAt(0);
			ctrUrl = service.getControlURL();
			System.out.println("Level 4: MSDA control URL "+ctrUrl);
		}
		else {
			System.out.println("Level 4: could not find the MSDA service");
			System.exit(-1);
		}
		System.out.println("Level 5");  
	}
	catch(Exception ex)
	{
		ex.printStackTrace();
	}
	
	
	org.msda.MSDClientAPIService.MSDClientAPIPortType service = new MSDClientAPIBindingStub(ctrUrl);
	//MSDClientAPIService.MSDClientAPIPortType service = new MSDClientAPIBindingStub("http://128.93.9.15:8080/discovery/serviceaccess");
	
	MSDRequestImpl msdRequest = new MSDRequestImpl();
	ReqDescriptionInformation reqDescription = new ReqDescriptionInformationImpl();
	
	RequestService requestService = new RequestServiceImpl();
	//requestService.setName("uuid:0000E8699FB4:urn:schemas-upnp-org:service:service1:1:0");
	//requestService.setName("urn:schemas-upnp-org:service:service1:1:0");
	//requestService.setName("uuid:0000E8699FB4:service1");
	requestService.setName("Movie");

	// Required Methods 
//    List methods = requestService.getMethods();
//    Method method = new MethodImpl();
//    method.setName("setName");
//    List paramIn  = method.getInputs();
//    List paramOut = method.getOutputs();
//    
//    Param param1 = new ParamImpl();
//    param1.setName("name");
//    
//    Param param2 = new ParamImpl();
//    param2.setName("return");
//    
//    paramIn.add(param1);
//    paramOut.add(param2);
//    
//    methods.add(method);
//        
//    Method method2 = new MethodImpl();
//    method2.setName("getName");
//    
//    List paramOut2 = method2.getOutputs();
//    	    	    
//    Param param22 = new ParamImpl();
//    param22.setName("return");
//    
//    paramOut2.add(param22);
//    
//    methods.add(method2);
    
	reqDescription.setService(requestService);
    msdRequest.setDescInfo(reqDescription);
    
    try
	{
    MSDDescriptionImpl[] msdDescs = service.getServices(msdRequest);
    System.out.println("service invoked");
    if (msdDescs != null)
    {
    	if (msdDescs.length>0)
    	{
    		MSDDescriptionImpl desc = msdDescs[0];
    		System.out.println("EP service="+desc.getSvcDef().getGeneric().getAddr().getLocation());
    		List methods = desc.getSvcDef().getGeneric().getMethods();
			for (int d=0; d<methods.size();d++)
			{
				Method method = (Method)methods.get(d);
				System.out.println("msdService methodName="+method.getName());
				List paramIn = method.getIn();
				List paramOut = method.getOut();
				
				for (int k=0; k<paramIn.size(); k++)
				{	
					Param param = (Param)paramIn.get(k);
					System.out.println("msdService in Param "+param.getType());
				}
		
				for (int u= 0 ;u<paramOut.size(); u++)
				{
					Param param = (Param)paramOut.get(u);
					System.out.println("msdService out Param"+param.getType());
				}
			}
			System.out.println("*******************************");
    		
			
			// getClient ID function
//			int id = service.getClientID(desc);
//			System.out.println("id = "+id);

    	}
    	else System.out.println("the result is Empty");
    }
    else System.out.println("the result is null");
	}
    catch(Exception ex)
	{
    	ex.printStackTrace();
	}
}

	public static void main(String[] args) {
		
		clientUPnP app = new clientUPnP();
		app.callService();
	}
}
