/*
 * Created on June 13, 2005
 *
 * INRIA, ARLES Project
 * 
 * contact: Pierre-Guillaume.Raverdy@inria.fr<br>
 *          Rafik.Chibout@inria.fr
 * 
 * Copyright INRIA 2005
 */
package org.msda.clientsamples.upnp.printer;

import java.awt.Button;
import java.awt.Label;
import java.awt.List;
import java.awt.Panel;
import java.awt.ScrollPane;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


/**
 * Class that creates the access panel.
 *
 * @author agnes.de_la_chapelle@inria.fr - INRIA ARLES
 */
public class AccessPanel extends Panel {

    private static final String BUTTON1 = "Get infos";
    private static final String BUTTON2 = "Get Pictures";
    private static final String BUTTON3 = "Set info";
    private static final String BUTTON4 = "Set infos";
    private static final String BUTTON_BACK = "Back"; 
    
    private Button button1;
    private Button button2; 
    private Button button3; 
    private Button button4; 
    private Button buttonBack;
    
    private Label label;
    private TextField textNumber; 
    
    private ScrollPane scroll;
    private List list;
    private ClientGUI clientGUI;
    
    /**
     * Constructor for the access panel.
     * 
     * @param client
     */
    public AccessPanel( ClientGUI client  ) {
     
        setSize( ClientGUI.WIDTH, 200 );
        
        this.clientGUI = client;
        
        label = new Label("No access possible...");
        add( label );
        
//        label = new Label( "# RFID" );
//        textNumber = new TextField( "4-010165-314153" );
//        
//        Label label2 = new Label( "       " );
//        
//        initButton();
//        
//        Panel tmpPanel = new Panel();
//        tmpPanel.add( buttonBack );
//        tmpPanel.add( label2 );
//        tmpPanel.add( label );
//        tmpPanel.add( textNumber );
//       
//        list = new List();
//        scroll = new ScrollPane();
//        scroll.add( list );
//        scroll.setSize( ClientGUI.WIDTH-20, ClientGUI.HEIGHT-100 );
//        
//        Panel buttonsPanel = new Panel();
//        buttonsPanel.add( button1 );
//       // buttonsPanel.add( button2 );
//        buttonsPanel.add( button3 );
//        //buttonsPanel.add( button4 );
//        
//        GridBagLayout gridbag = new GridBagLayout();
//        GridBagConstraints c = new GridBagConstraints();
//        c.gridwidth = GridBagConstraints.REMAINDER;
//        gridbag.setConstraints( tmpPanel, c);
//        
//        gridbag.setConstraints( buttonsPanel, c);
//        
//        c.fill = GridBagConstraints.BOTH;
//        gridbag.setConstraints( scroll, c);
//        
//        setLayout(gridbag);
//        
//        add( tmpPanel );
//        add( buttonsPanel );
//        add( scroll );
    }
    
    /**
     * Removes all the elements of the list.
     */
    public void cleanList() {
        
        list.setEnabled( false );
        list.removeAll();
        list.setEnabled( true );
    }
    
    /**
     * Creates all the buttons.
     */
    private void initButton() {
        
        ActionListener buttonListener = new ButtonActionListener();
        
        buttonBack = new Button( BUTTON_BACK );
        buttonBack.addActionListener( buttonListener );
        
        button1 = new Button( BUTTON1 );
        button1.addActionListener( buttonListener );
        
        button2 = new Button( BUTTON2 );
        button2.addActionListener( buttonListener );
        
        button3 = new Button( BUTTON3 );
        button3.addActionListener( buttonListener );
        
        button4 = new Button( BUTTON4 );
        button4.addActionListener( buttonListener );
    }
    
    /**
     * Action associated with the "Get infos" button.
     */
    private void action1() {
        
        list.setEnabled( false );
        list.removeAll();
        
        try {	
            // case UPnP or MSD
            // call the service access
//            RFIDMusicPortType rfidService = clientGUI.getClient().getRfidService();
//            String chain = rfidService.getInfo(textNumber.getText().trim());
//           
//            if (chain != null && !chain.equals("")) {
//                
//                int indexOfSpeCar = 0;
//                int indexOfSpeCar2 = 0;
//                while (indexOfSpeCar != -1) {
//                    
//                    indexOfSpeCar2 = chain.indexOf("#", indexOfSpeCar);
//                    if ( indexOfSpeCar2 < 0 )
//                        break;
//                    list.add( chain.substring(indexOfSpeCar, indexOfSpeCar2) );
//                    indexOfSpeCar = chain.indexOf("#", indexOfSpeCar)+1;
//                }
//            }
//            
//            if ( chain != null && chain.equals("") ) {
//                JOptionPane.showMessageDialog(this,"There is no results.","Search result",JOptionPane.INFORMATION_MESSAGE);
//            }
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
        list.setEnabled( true );
    }
    
    private void action2() {
    }
    
    /**
     * Action associated with the "Set info" button.
     */
    private void action3() {
    }
    
    /**
     * Action associated with the "Set infos" button.
     */
    private void action4() {
    }
    
    /**
     * Action associated with the "Back" button.
     */
    private void actionBack() {
        clientGUI.back();
    }
    
    /**
     * Class that defines the actions when a button is pressed.
     * 
     * @author agnes.de_la_chapelle@inria.fr - INRIA ARLES
     *
     */
    class ButtonActionListener implements ActionListener  {
      
      public void actionPerformed(ActionEvent ae) {
          
          String action = ae.getActionCommand();
          
          if ( BUTTON1.equals( action ) ) {
              action1();
              
          } else if ( BUTTON2.equals( action ) ) {
              action2();
              
          } else if ( BUTTON3.equals( action ) ) {
              action3();
              
          } else if ( BUTTON4.equals( action ) ) {
              action4();
              
          } else if ( BUTTON_BACK.equals( action ) ) {
              actionBack();
          } 
      }
    }
}
