/*
 * Created on Jul 5, 2005
 * @author raverdy
 * Comments, questions: Pierre-Guillaume.Raverdy@inria.fr
 *
 * Copyright INRIA, 2004-2005
 * UBISEC
 * This code should not be distributed
 */ 
package org.msda.tests;

import org.msda.components.core.MSDNetwork;
import org.msda.components.interfaces.*;
import org.msda.framework.FrameworkOutput;
import org.msda.gui.*;
import org.msda.msd.*;
import org.msda.msd.impl.*;
import org.msda.util.*;
import org.msda.util.comm.MulticastGroup;

import java.text.*;
import java.util.*;
import java.io.*;
import java.math.BigInteger;

import javax.xml.bind.*;
import org.xml.sax.*; 

import org.apache.log4j.*;

/*
 * @author raverdy
 */
public class TestCommunicationManager {

	
		public void startTest (String[] args, FrameworkOutput board )
		{
			BufferedReader standard = new BufferedReader(new InputStreamReader(System.in));
			String ifname, groupAddress, devName;
			int groupPort, testNumber;
			MulticastGroup mgroup;

			testNumber = Integer.parseInt(args[1]);
			ifname = args[2];
			groupAddress = args[3];
			groupPort = Integer.parseInt(args[4]);
			devName = args[5];

		    MSDNetwork coreNet;
		    coreNet = new MSDNetwork();
		    coreNet.setBoard(null);
			CallBackTestComm client1, client2, client3;			
		    CommunicatorInterface comm1, comm2, comm3;

			UbisecID netId = new UbisecIDImpl ();

			switch (testNumber)
			{
				case 0:
				{
					// second set of tests for the networtk communicator callback
					
					try {
						//
						//
						System.out.println (" - creating client1");
						client1 = new CallBackTestComm ( devName + "_client1" );
						comm1 = coreNet.registerCallback( netId, ifname, groupAddress, groupPort, client1 );
						client1.registerCommunicator (comm1);

						System.out.println (" - creating client2");
						client2 = new CallBackTestComm ( devName + "_client2" );
						comm2 = coreNet.registerCallback( netId, ifname, groupAddress, groupPort, client2 );
						client2.registerCommunicator (comm2);

						System.out.println (" - creating client3");
						client3 = new CallBackTestComm ( devName + "_client3" );
						comm3 = coreNet.registerCallback( netId, ifname, groupAddress, groupPort, client3 );
						client3.registerCommunicator (comm3);

						//
						//
						System.out.println (" - client1 sends msddescr");
						MSDDescription descr = new MSDDescriptionImpl ();
						descr.setMSDDescriptionID( devName + "_client1" );
						comm1.sendDescription(descr);

						//
						//
						System.out.println ("Enter a line to exit");
						try{
							String inline = standard.readLine();
						}
						catch (Exception e)
						{
						}
						
						// now I should terminate all clients
					}
					catch (MSDException e)
					{
						
					}				
				}
				break;
			}

			System.out.println (" - exit?");
			System.exit(0);
		}
		

		public class CallBackTestComm implements CommunicatorCallback {
			String clientName;
			MulticastGroup mgroup;
			FrameworkOutput board;
			CommunicatorInterface comm;

			public CallBackTestComm (String clientName)
			{
				this.clientName = clientName;
			}
			
			public void registerCommunicator (CommunicatorInterface comm)
			{
				this.comm = comm;
			}

			public void newDescription(MSDDescription description)
			{
				System.out.println ( clientName + ": received a description with ID " + description.getMSDDescriptionID() );
				if (description.getMSDDescriptionID().equals("device1_client4"))
					if (clientName.equals("device1_client5"))
					{
						try {
							System.out.println ("I am client device1_client5 and I received device1_client4...send back a response");
							description.setMSDDescriptionID("response");
							comm.sendDescription(description);											
						}
						catch (MSDException e)
						{
							
						}
					}
						
			}
			
			public void newRequest(MSDRequest request)		
			{
				
			}

			public void responseRequest(MSDMessage message)
			{
				
			}

			public void controlMessage( MSDMessage message )
			{
				
			}
		}
}
		
