/*
 * Created on Jun 29, 2005
 * @author raverdy
 * Comments, questions: Pierre-Guillaume.Raverdy@inria.fr
 *
 * Copyright INRIA, 2004-2005
 * UBISEC
 * This code should not be distributed
 */ 
package org.msda.tests;

import org.apache.log4j.Appender;
import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.FileAppender;
import org.apache.log4j.Logger;
import org.apache.log4j.PatternLayout;

import org.msda.components.interfaces.*;
import org.msda.framework.FrameworkOutput;
import org.msda.gui.*;
import org.msda.msd.*;
import org.msda.msd.impl.*;
import org.msda.util.*;

import java.text.*;
import java.util.*;
import java.io.*;
import java.math.BigInteger;

import javax.xml.bind.*;
import org.xml.sax.*; 

import org.apache.log4j.*;

/*
 * @author raverdy
 */
public class TestMain {

	public static void main(String[] args) 
	{
		Vector vect = new Vector();
		TestMulticastGroup testMulticast;
		TestBridge testBridge;
		TestCommunicationManager testCommunicationManager;
		
		// Naming of the log4j files
	    String pattern = "%d{HH:mm:ss,SSS} %p [%t] %m%n";
	    PatternLayout patternLayout = new PatternLayout( pattern );
		Logger log = Logger.getLogger( "msd_tests.log" );
		FrameworkOutput board = new FrameworkOutput (log);
		Appender appender;
        try {
            appender = new FileAppender(patternLayout, "msd_tests.log"  );
            log.addAppender( appender );
        } catch (IOException e1) {
            e1.printStackTrace();
        } finally {
            // use a console appender in all cases
            log.addAppender( new ConsoleAppender(patternLayout));   
        }

        if (args[0].equals("multicast"))
        {
    		testMulticast = new TestMulticastGroup();
    		System.out.println("- starting multicast tests");
    		testMulticast.startTest (args, board);        	
        }

        if (args[0].equals("communication"))
        {
        	testCommunicationManager = new TestCommunicationManager();
    		System.out.println("- starting communication manager tests");
    		testCommunicationManager.startTest (args, board);        	
        }

        if (args[0].equals("bridge"))
        {
    		System.out.println("- starting bridge tests");
    		testBridge = new TestBridge(args, board);
        }

	}
	

}
