/*
 * Created on Sep 9, 2005
 * 
 * INRIA, ARLES Project
 * 
 * contact: Pierre-Guillaume.Raverdy@inria.fr
 * Preliminary version, please do not distribute
 * 
 * Copyright INRIA 2005
 */
package org.msda.tests.more;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.StringWriter;
import java.net.MalformedURLException;
import java.text.FieldPosition;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;

import org.apache.log4j.Appender;
import org.apache.log4j.Logger;
import org.apache.log4j.PatternLayout;
import org.apache.log4j.RollingFileAppender;
import org.msda.msd.MSDMessage;
import org.msda.msd.impl.MSDMessageImpl;
import org.msda.util.JaxMeUtil;
import org.xml.sax.InputSource;

/**
 * @author agnes.de_la_chapelle@inria.fr - INRIA ARLES
 *
 */
public class TestJaxme {

    
    public static void main(String[] args) {
        
        String pattern = "%m%n";//"%d{HH:mm:ss,SSS} %p [%t] %m%n";
		PatternLayout patternLayout = new PatternLayout( pattern );
		SimpleDateFormat format = new SimpleDateFormat( "yyyyMMdd");
		StringBuffer buffer = format.format( Calendar.getInstance().getTime(), new StringBuffer(), new FieldPosition( NumberFormat.INTEGER_FIELD ) );
		String date = buffer.toString();
		String filename = date +"_jaxme.unmarshall.log";
		Logger log = Logger.getLogger( filename );
		String filename2 = date +"_jaxme.marshall.log";
		Logger log2 = Logger.getLogger( filename2 );
		Appender appender;
		try {
			appender = new RollingFileAppender(patternLayout, filename  );
			log.addAppender( appender );
			appender = new RollingFileAppender(patternLayout, filename2  );
			log2.addAppender( appender );
		} catch (IOException e1) {
			e1.printStackTrace();
		} 
		
		System.out.println("START");
        
        try {
            JAXBContext context = JAXBContext.newInstance("org.ubisec.msd");
            Unmarshaller unmarshaller = context.createUnmarshaller();
            Marshaller marshaller = context.createMarshaller();
            
            
            
            for (int i=0;i<50; i++) {
                
                File f = new File("src/org/ubisec/tests/msd/descTest.xml");
                FileInputStream input = new FileInputStream(f);
                InputSource isource = new InputSource(input);
                isource.setSystemId(f.toURL().toString());
                
                
                long start = System.currentTimeMillis();
                MSDMessage message = (MSDMessageImpl) unmarshaller.unmarshal(isource);
                long end = System.currentTimeMillis();
                long diff = end - start;
                log.info(Long.toString(diff));
                
                StringWriter sw = new StringWriter();
                
                start = System.currentTimeMillis();
                marshaller.marshal( message, sw );
                end= System.currentTimeMillis();
                diff = end - start;
                log2.info(Long.toString(diff));
                
                try {
                    input.close();
                } catch (IOException e2) {
                    // TODO Auto-generated catch block
                    e2.printStackTrace();
                }
                
                try {
                    Thread.sleep(500);
                } catch (InterruptedException e3) {
                    // TODO Auto-generated catch block
                    e3.printStackTrace();
                }
            }
            
            
            
            
            System.out.println("END");
            
        } catch (FileNotFoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (MalformedURLException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (JAXBException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        
        
        //
    }
}
