/*
 * Created on 17 fvr. 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

package org.msda.upnpdevice.sample.device1;

import com.siemens.upnp.devicehost.*;
import com.siemens.upnp.*;
import java.io.*;
import java.util.*;

import org.msda.upnpdevice.sample.device1.services.*;



/**
 * @author rafik
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

public class SampleDevice1 extends HostedDevice
{
	
	HostedService service;
	
	public SampleDevice1(File description) throws FileNotFoundException, InvalidDescriptionException 
	{
		super(description);
		initDevice();
	}
	
	public SampleDevice1()
	{
		createDevice();
		initDevice();
	}
	
	public void createDevice()
	{
		// required attributes
		this.setDeviceType("urn:schemas-upnp-org:device:rfid_device:1");
		this.setFriendlyName("Device1");
		this.setManufacturer("INRIA Arles Project");
		this.setModelName("Sample");
		this.setUDN("uuid:2000E8699FB4");
		//this.setUDN("uuid:0000E8699FB4");
		//this.setUrlBase("http://128.93.9.15:");
		this.setPresentationUrl(this.getUrlBase()+"/presentation.html");
		// recommend attributes
		this.setModelDescription("Sample Davice1 for UBISEC IST Project");
		this.setModelNumber("0.90");
		this.setSerialNumber("1234567890");
		// optionals attributes
		this.setManufacturerURL("http://www-rocq.inria.fr/arles");
		this.setModelURL("http://www-rocq.inria.fr/arles");
		this.setUPC("Samples");
		
		//icons
		Icon icon = new Icon("icon.gif");
		icon.setMimeType("image/gif");
		icon.setHeight(30);
		icon.setWidth(30);
		icon.setColorDepth(8);
		
		this.addIcon(icon);
		
		//embadded Devices
		// create embadded devices here
		
		
		// services
		service = this.createService();
		service.setServiceType("urn:schemas-upnp-org:service:RFIDMusicService");
		service.setServiceID("urn:upnp-org_urn:RFIDMusicService");
		//service.setControlURL("http://128.93.9.15:4444/controlurl");
		
		HostedStateVariable stateVarabileName = service.createStateVariable("name", "string","noname", "noname", true);
		service.addStateVariable(stateVarabileName);
		
		// 	action getInfo
		Argument argumentIn  = new Argument("RFID", Argument.IN, false, stateVarabileName.getName());
		Argument argumentOut = new Argument("return", Argument.OUT, true, stateVarabileName.getName());
		Action getInfoAction = service.createAction("getInfo");
		getInfoAction.addArgument(argumentIn);
		getInfoAction.addArgument(argumentOut);
		service.addAction(getInfoAction);
		
		//	 	action setInfo
		Argument argumentIn2  = new Argument("RFID", Argument.IN, false, stateVarabileName.getName());
		Argument argumentIn3  = new Argument("MusicInfo", Argument.IN, false, stateVarabileName.getName());
		Argument argumentOut2 = new Argument("return", Argument.OUT, true, stateVarabileName.getName());
		Action setInfoAction = service.createAction("setInfo");
		setInfoAction.addArgument(argumentIn2);
		setInfoAction.addArgument(argumentIn3);
		setInfoAction.addArgument(argumentOut2);
		service.addAction(setInfoAction);
		
		
		//	 	action setInfos
		Argument argumentIn5  = new Argument("RFID", Argument.IN, false, stateVarabileName.getName());
		Argument argumentIn6  = new Argument("MusicInfo", Argument.IN, false, stateVarabileName.getName());
		Argument argumentOut4 = new Argument("return", Argument.OUT, true, stateVarabileName.getName());
		Action setInfosAction = service.createAction("setInfos");
		setInfosAction.addArgument(argumentIn5);
		setInfosAction.addArgument(argumentIn6);
		setInfosAction.addArgument(argumentOut4);
		service.addAction(setInfosAction);
		
		//	 	action getImage
		Argument argumentIn4  = new Argument("RFID", Argument.IN, false, stateVarabileName.getName());
		Argument argumentOut3 = new Argument("return", Argument.OUT, true, stateVarabileName.getName());
		Action getImageAction = service.createAction("getImage");
		getImageAction.addArgument(argumentIn4);
		getImageAction.addArgument(argumentOut3);
		service.addAction(getImageAction);
		
		
		this.addService(service);
		System.out.println("****************Device Decription**********************");
		System.out.println(this.getDeviceDescription());
		System.out.println("*************************************************");
		
		System.out.println("****************Service Decription**********************");
		Enumeration services = this.getServices().elements();
		if (services.hasMoreElements()) 
		{
			HostedService serviceTmp = (HostedService)services.nextElement();
			System.out.println(serviceTmp.getDescription());	
		}
		System.out.println("*************************************************");
		
				
	}
	
	public void initDevice()
	{
		this.setRootDevice(true);
		UPnPPresentationPageHandler pageHandler = new SampleDevice1PresentationPageHandler();
		this.setPresentationPageHandler(pageHandler);
		SampleDevice1_Service1Interface service1 = new SampleDevice1_Service1Impl();
		UPnPActionListener service1ActionListner = new SampleDevice1_Service1ActionRequest(service1, service);
		Enumeration services = this.getServices().elements();
		while (services.hasMoreElements())
		{
			HostedService service = (HostedService)services.nextElement();
			service.setActionListener(service1ActionListner);
		}
		this.setLeaseTime(9999);
	}
 }
