/*
 * Created on 11 mai 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package soap;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.Field;

import javax.xml.namespace.QName;



/**
 * @author rafik
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SoapExt {

	TypeMapping typeMapping = null;
	public void addSoapExt(File folder , String namespace)
	{
		typeMapping = new TypeMapping(namespace);
		
		File[] fileNames = folder.listFiles();
		if (fileNames != null)
		{
			for (int i=0; i< fileNames.length; i++)
				if (!fileNames[i].isDirectory())
				{
					StringBuffer fileContent = FileTools.readFile(fileNames[i]);
					replace(fileContent, "private" , "public");
					replace(fileContent, "public final" , "private final");
					addTypeDescFunction(fileContent, fileNames[i].getName());
					try
					{
						FileTools.writeFile(fileNames[i], fileContent);
					}
					catch(IOException ex)
					{
						ex.printStackTrace();
					}
				}
		}
	}
	
	public void addTypeDescFunction(StringBuffer content, String fileName)
	{
		StringBuffer typeDescPart = new StringBuffer();
		try
		{
			typeDescPart.append("//Type metadata\n");
			typeDescPart.append("\tprivate static csoap.wsdl.TypeDesc typeDesc=new csoap.wsdl.TypeDesc("+fileName.replaceFirst(".java", ".class")+");\n\n");
			
			typeDescPart.append("\tstatic {\n");
			typeDescPart.append("\t\ttypeDesc.setXmlType(new javax.xml.namespace.QName("+'"'+typeMapping.getNamespace()+'"'+","+'"'+fileName.replaceFirst(".java","")+'"'+"));\n");
			typeDescPart.append("\t\tcsoap.wsdl.ElementDesc elementField;\n\n");
			String packageName = content.substring(content.indexOf("package")+7, content.indexOf(";")).trim();
			
			String className = packageName+"."+fileName.replaceFirst(".java", "");

			Class classValue = Class.forName(className);
			Field[] fields = classValue.getDeclaredFields();
			if (fields != null)
				for (int i=0; i<fields.length; i++)
				{
					QName xmlType = typeMapping.getXMLType(fields[i].getType());
					
					typeDescPart.append("\t\telementField=new csoap.wsdl.ElementDesc();\n");
					typeDescPart.append("\t\telementField.setFieldName("+'"'+fields[i].getName()+'"'+");\n");
					typeDescPart.append("\t\telementField.setXmlName(new javax.xml.namespace.QName("+'"'+'"'+","+'"'+fields[i].getName()+'"'+"));\n");
					typeDescPart.append("\t\telementField.setXmlType(new javax.xml.namespace.QName("+'"'+xmlType.getNamespaceURI()+'"'+","+'"'+xmlType.getLocalPart()+'"'+"));\n");
					typeDescPart.append("\t\ttypeDesc.addFieldDesc(elementField);\n\n");
				}
			
		typeDescPart.append("\t}\n\n");

		typeDescPart.append("\t/**\n");
		typeDescPart.append("\t* Return type metadata object\n");
		typeDescPart.append("\t*/\n");
		typeDescPart.append("\tpublic static csoap.wsdl.TypeDesc getTypeDesc() {\n");
		typeDescPart.append("\t\treturn typeDesc;\n");
		typeDescPart.append("\t}\n\n");
		
		int insertIndex = content.lastIndexOf("}");
		content.deleteCharAt(insertIndex);
		content.append(typeDescPart+"\n\n");
		content.append("}\n");
		
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	public void replace(StringBuffer content, String oldChaine, String newChaine)
	{
		int boundStart = content.indexOf("{");
		int boundEnd   = content.indexOf("{", boundStart+1);
		int index = boundStart;
		
		while (index !=-1 && index<boundEnd)
		{
			index = content.indexOf(oldChaine, index+1);
			if (index !=-1 && index<boundEnd) content = content.replace(index, index+oldChaine.length(), newChaine);
		}
		
	}
	
	
	public static void main(String[] args) {
		if (args == null || args.length<2) 
		{
			System.out.println("Arguments missing : folder name or namespace");
			return;
		}
		File folder = new File(args[0]);
		if (!folder.isDirectory())
		{
			System.out.println(args[0] +" is not a Directory");
			return;
		}
		
		String namespace = args[1];
		SoapExt app = new SoapExt();
		app.addSoapExt(folder, namespace);
	}
}
