/**
 * 
 */

package org.msda.soap;

import java.util.Calendar;
import java.util.Iterator;
import java.util.List;

import csoap.xml.soap.*;
import javax.xml.soap.*;
import javax.xml.namespace.QName;
import csoap.xml.rpc.encoding.*;
import javax.xml.rpc.encoding.*;

import org.msda.msd.*;
import org.msda.msd.impl.*;

import java.io.*;
import java.lang.reflect.*;

import csoap.deployment.*;


public class SOAPTools {
	
    MessageFactoryImpl factory = new MessageFactoryImpl();
    static TypeMappingRegistryImpl typeRegistry;
    static TypeMapping typeMapping;
    static deployedServices objectServices;	 
    
    DeserializerFactory deserializerFactory;
    SerializerFactory serializerFactory;
    DeserializerBase deserializer;
    SerializerBase serializer;
    
    public SOAPTools(String fileName) throws FileNotFoundException
    {
    	typeRegistry = new TypeMappingRegistryImpl();
    	objectServices = new deployedServices();
    	deployment deploy = new deployment(objectServices, typeRegistry, null);
    	FileInputStream deployFile = new FileInputStream(fileName);
    	deploy.deploy(deployFile, objectServices);
    }

    /// Class Holder Manager

    private static Class getJavaTypeHolder(String XMLDataType, String namespace) 
    {
    	Class ret = null;
    	String schemaNameSpace1999="http://www.w3.org/1999/XMLSchema";
    	String schemaNameSpace2000="http://www.w3.org/2000/XMLSchema";
    	String schemaNameSpace2001="http://www.w3.org/2001/XMLSchema";
    	String soapNameSpace="http://schemas.xmlsoap.org/soap/encoding/";
    	String wsdlNameSpace="http://schemas.xmlsoap.org/wsdl/";
    	//	case XML Schema type)
    	if ((namespace.equals(schemaNameSpace1999))||
	    (namespace.equals(schemaNameSpace2000))||
	    (namespace.equals(schemaNameSpace2001))) {
		if (XMLDataType.equals("string")) ret=javax.xml.rpc.holders.StringHolder.class;
		else if (XMLDataType.equals("integer")) ret=javax.xml.rpc.holders.BigIntegerHolder.class;
		else if (XMLDataType.equals("int")) ret=javax.xml.rpc.holders.IntHolder.class;
		else if (XMLDataType.equals("short")) ret=javax.xml.rpc.holders.ShortHolder.class;
		else if (XMLDataType.equals("decimal")) ret=javax.xml.rpc.holders.BigDecimalHolder.class;

		//****************************************************
		//********* ADD FOR BIGDECIMAL SUPPORT WITH CVM
		//****************************************************
		
		//else if (XMLDataType.equals("decimal") && BigDecimalSupported) ret=javax.xml.rpc.holders.BigDecimalHolder.class;
		//else if (XMLDataType.equals("decimal") && !BigDecimalSupported) ret=javax.xml.rpc.holders.DoubleHolder.class;
		 
		else if (XMLDataType.equals("float")) ret=javax.xml.rpc.holders.FloatHolder.class;
		else if (XMLDataType.equals("double")) ret=javax.xml.rpc.holders.DoubleHolder.class;
		else if (XMLDataType.equals("boolean")) ret=javax.xml.rpc.holders.BooleanHolder.class;
		else if (XMLDataType.equals("byte")) ret=javax.xml.rpc.holders.ByteHolder.class;
		else if (XMLDataType.equals("QName")) ret=javax.xml.rpc.holders.QNameHolder.class;
		else if (XMLDataType.equals("DateTime")) ret=javax.xml.rpc.holders.CalendarHolder.class;
		else if (XMLDataType.equals("base64Binary")) ret=javax.xml.rpc.holders.ByteArrayHolder.class;
		else if (XMLDataType.equals("hexBinary")) ret=javax.xml.rpc.holders.ByteArrayHolder.class;
    	}
    	else if (namespace==soapNameSpace) {
		if (XMLDataType.equals("string")) ret=javax.xml.rpc.holders.StringHolder.class;
		else if (XMLDataType.equals("boolean")) ret=javax.xml.rpc.holders.BooleanWrapperHolder.class;
		else if (XMLDataType.equals("float")) ret=javax.xml.rpc.holders.FloatWrapperHolder.class;
		else if (XMLDataType.equals("double")) ret=javax.xml.rpc.holders.DoubleWrapperHolder.class;
		else if (XMLDataType.equals("decimal")) ret=javax.xml.rpc.holders.BigDecimalHolder.class;
		//****************************************************
		//********* ADD FOR BIGDECIMAL SUPPORT WITH CVM
		//****************************************************
		
		//else if (XMLDataType.equals("decimal") && BigDecimalSupported) ret=java.xml.rpc.holders.BigDecimalHolder.class;
		//else if (XMLDataType.equals("decimal") && !BigDecimalSupported) ret=java.xml.rpc.holders.DoubleHolder.class;
		
		else if (XMLDataType.equals("int")) ret=javax.xml.rpc.holders.IntegerWrapperHolder.class;
		else if (XMLDataType.equals("short")) ret=javax.xml.rpc.holders.ShortWrapperHolder.class;
		else if (XMLDataType.equals("byte")) ret=javax.xml.rpc.holders.ByteWrapperHolder.class;
		//else if (XMLDataType.equals("base64")) ret="Java.xml.rpc.holders. ";
    	}	
    	return ret;
    }	

    // object Holder manager

   
private static Object getObjectHolder(String XMLDataType, String namespace, Object obj) 
{
	Object ret =null;
	String schemaNameSpace1999="http://www.w3.org/1999/XMLSchema";
	String schemaNameSpace2000="http://www.w3.org/2000/XMLSchema";
	String schemaNameSpace2001="http://www.w3.org/2001/XMLSchema";
	String soapNameSpace="http://schemas.xmlsoap.org/soap/encoding/";
	String wsdlNameSpace="http://schemas.xmlsoap.org/wsdl/";

	//case XML Schema type)
	if ((namespace.equals(schemaNameSpace1999))||
	    (namespace.equals(schemaNameSpace2000))||
	    (namespace.equals(schemaNameSpace2001))) {
	    if (XMLDataType.equals("string")) ret= new javax.xml.rpc.holders.StringHolder(obj.toString());
		else if (XMLDataType.equals("integer")) ret= new javax.xml.rpc.holders.BigIntegerHolder((java.math.BigInteger)obj);
		else if (XMLDataType.equals("int")) ret= new javax.xml.rpc.holders.IntHolder(((java.lang.Integer)obj).intValue());
		else if (XMLDataType.equals("short")) ret= new javax.xml.rpc.holders.ShortHolder((new java.lang.Short(obj.toString())).shortValue());
		else if (XMLDataType.equals("decimal")) ret= new javax.xml.rpc.holders.BigDecimalHolder(new java.math.BigDecimal(obj.toString()));

		//****************************************************
		//********* ADD FOR BIGDECIMAL SUPPORT WITH CVM
		//****************************************************
		
		//else if (XMLDataType.equals("decimal") && BigDecimalSupported) ret= new javax.xml.rpc.holders.BigDecimalHolder(new java.math.BigDecimal(obj.toString()));
		//else if (XMLDataType.equals("decimal") && !BigDecimalSupported) ret= new javax.xml.rpc.holders.DoubleHolder((new java.lang.Double(obj.toString())).doubleValue());
		 
		else if (XMLDataType.equals("float")) ret= new javax.xml.rpc.holders.FloatHolder((new java.lang.Float(obj.toString())).floatValue());
		else if (XMLDataType.equals("double")) ret= new javax.xml.rpc.holders.DoubleHolder((new java.lang.Double(obj.toString())).doubleValue());
		else if (XMLDataType.equals("boolean")) ret= new javax.xml.rpc.holders.BooleanHolder((new java.lang.Boolean(obj.toString())).booleanValue());
		else if (XMLDataType.equals("byte")) ret= new javax.xml.rpc.holders.ByteHolder((new java.lang.Byte(obj.toString())).byteValue());
		else if (XMLDataType.equals("QName")) ret= new javax.xml.rpc.holders.QNameHolder((QName)obj);
		else if (XMLDataType.equals("DateTime")) ret= new javax.xml.rpc.holders.CalendarHolder((java.util.Calendar)obj);
		else if (XMLDataType.equals("base64Binary")) ret= new javax.xml.rpc.holders.ByteArrayHolder((byte[])obj);
		else if (XMLDataType.equals("hexBinary")) ret= new javax.xml.rpc.holders.ByteArrayHolder((byte[])obj);
	}
	else if (namespace==soapNameSpace) {
		if (XMLDataType.equals("string")) ret= new javax.xml.rpc.holders.StringHolder(obj.toString());
		else if (XMLDataType.equals("boolean")) ret= new javax.xml.rpc.holders.BooleanWrapperHolder(new java.lang.Boolean(obj.toString()));
		else if (XMLDataType.equals("float")) ret= new javax.xml.rpc.holders.FloatWrapperHolder(new java.lang.Float(obj.toString()));
		else if (XMLDataType.equals("double")) ret= new javax.xml.rpc.holders.DoubleWrapperHolder(new java.lang.Double(obj.toString()));
		else if (XMLDataType.equals("decimal")) ret= new javax.xml.rpc.holders.BigDecimalHolder(new java.math.BigDecimal(obj.toString()));
		//****************************************************
		//********* ADD FOR BIGDECIMAL SUPPORT WITH CVM
		//****************************************************
		
		//else if (XMLDataType.equals("decimal") && BigDecimalSupported) ret= new java.xml.rpc.holders.BigDecimalHolder(new java.math.BigDecimal(obj.toString()));
		//else if (XMLDataType.equals("decimal") && !BigDecimalSupported) ret= new java.xml.rpc.holders.DoubleWrapperHolder(new java.lang.Double(obj.toString()));
		
		else if (XMLDataType.equals("int")) ret= new javax.xml.rpc.holders.IntegerWrapperHolder(new java.lang.Integer(obj.toString()));
		else if (XMLDataType.equals("short")) ret= new javax.xml.rpc.holders.ShortWrapperHolder(new java.lang.Short(obj.toString()));
		else if (XMLDataType.equals("byte")) ret= new javax.xml.rpc.holders.ByteWrapperHolder((java.lang.Byte)obj);
		//else if (XMLDataType.equals("base64")) ret= new javax.xml.rpc.holders. ";
	}
	return ret;
}

public String getClassHolderName(String ClassXMLName, String packageName)
  {
	String firstCar = ClassXMLName.substring(0,1);
	firstCar.toUpperCase();
	String withoutFirstCar = ClassXMLName.substring(1);
	ClassXMLName = firstCar+withoutFirstCar;
	
	try
	  {
		Class myClass = Class.forName(packageName+".holders."+ClassXMLName+"Holder");
	  }
	catch(Exception ex)
	  {
		System.out.println("Error in instance of "+ packageName+".holders."+ClassXMLName+"Holder");
	  }
	
	return packageName+".holders."+ClassXMLName+"Holder";
  }
    

//
    
public Object SOAP2Java(Reader reader, String serviceName) 
    {
     	SOAPMessageImpl sOAPMessage = null;
    	javax.xml.rpc.soap.SOAPFaultException SOAPException = null;
        try
		{
        	sOAPMessage = (SOAPMessageImpl)factory.createMessage(null, reader);
   	 	}
        catch (Exception ex)
		{
        	SOAPException = new javax.xml.rpc.soap.SOAPFaultException(QName.valueOf("Client"), "Message SOAP incorrectly formed", serviceName, null);
        	return null;
		}
        return getSOAPMessage(sOAPMessage, serviceName);
   }   

    
public Object SOAP2Java(InputStream is, String serviceName) 
    {
     	SOAPMessageImpl sOAPMessage = null;
    	javax.xml.rpc.soap.SOAPFaultException SOAPException = null;
        try
		{
        	sOAPMessage = (SOAPMessageImpl)factory.createMessage(null, is);
   	 	}
        catch (Exception ex)
		{
        	SOAPException = new javax.xml.rpc.soap.SOAPFaultException(QName.valueOf("Client"), "Message SOAP incorrectly formed", serviceName, null);
        	return null;
		}
    return getSOAPMessage(sOAPMessage, serviceName);
   }   

public Object getSOAPMessage(SOAPMessage sOAPMessage, String serviceName) 
    {
	 QName  operationName = null;
     boolean methodHasReturn = false;
     String className="";
     
     Class parameterJAVATypes[] = null; 
     Object parameterValues[] = null;
     Iterator childs;
             
     Service service = objectServices.getService(serviceName);
     if (service == null) 
	 System.out.println("Service "+serviceName+" not exist in this server");
     
     Operation operation =  null;
     //String method = null;
     int nParams = 0;
     Object obj =null;
     int i = 0;
     Iterator params = null;

     String type="", prefix="";
     javax.xml.rpc.soap.SOAPFaultException SOAPException = null;
     
     boolean bool = true;
     try
		 {
		     SOAPPartImpl sOAPPart = (SOAPPartImpl)sOAPMessage.getSOAPPart();
		     SOAPEnvelopeImpl sOAPEnvelope = (SOAPEnvelopeImpl) sOAPPart.getEnvelope();
		     SOAPBodyImpl sOAPBoby = (SOAPBodyImpl) sOAPEnvelope.getBody();
		     childs = sOAPBoby.getChildElements();
		     SOAPBodyElementImpl sOAPBodyElement = null;
		     SOAPElement sOAPElement = null;
		     if (childs.hasNext()) 
			 sOAPBodyElement = (SOAPBodyElementImpl)childs.next();
		     operationName = QName.valueOf("{"+sOAPBodyElement.getElementName().getURI()+"}"+sOAPBodyElement.getElementName().getLocalName());
		     operation = service.getOperation(operationName);
		     //method = operation.getName();

		     if (operation.getReturnType()!=null && !operation.getReturnType().equals("")) methodHasReturn = true;

		     className = service.getParameterValue("className");
		     nParams = operation.getNParameters();
		     parameterJAVATypes = new Class[nParams];
		     parameterValues = new Object[nParams];
		     i = 0;
		     params = operation.getParameters();
		     if (!methodHasReturn)
			 {
			     // are there parameter with OUT or INOUT mode?
			     while (params.hasNext() && !methodHasReturn )
				 {
				     parameterOperation paramTemp = (parameterOperation)params.next();
				     if (paramTemp.getMode().equals("OUT") || paramTemp.getMode().equals("INOUT")) methodHasReturn = true;
				 }
			     params = operation.getParameters();
			 }
		    		    
		     childs = sOAPBodyElement.getChildElements();
 		     // new add
		     while (params.hasNext()) 
			 {    
			     obj = null; 
			     parameterOperation param = (parameterOperation)params.next();
			     if ( !param.getMode().equals("OUT"))  
				 {
				     if (childs.hasNext()) 
				     sOAPElement = (SOAPElement)childs.next();
				     else System.out.println("Number of parameter error");
				     sOAPElement = Reference.getSOAPElementForDeserialiser(sOAPElement);
				     type = sOAPElement.getAttributeValue(new NameImpl("type"));
				     prefix ="";
				     if (type.indexOf(":") != -1 )
					 {
					     prefix = type.substring(0,type.indexOf(":"));
					     type = type.substring(type.indexOf(":")+1);
					 }
				     QName xmlType = QName.valueOf("{"+sOAPElement.getNamespaceURI(prefix)+"}"+type);
				     typeMapping = typeRegistry.getTypeMapping(xmlType.getNamespaceURI());   
				     deserializerFactory = typeMapping.getDeserializer(null,xmlType);   
				     deserializer = (DeserializerBase)deserializerFactory.getDeserializerAs("default");
				      
				     obj = deserializer.deserialize(sOAPElement,typeRegistry,service);   
				     if (param.getMode().equals("INOUT"))
					 {
					     javax.xml.rpc.holders.Holder obj2; ; 
					     if (obj != null) 
						 {
						     obj2 = (javax.xml.rpc.holders.Holder)getObjectHolder(param.getQName().getLocalPart(), param.getQName().getNamespaceURI(), obj);
						     if (obj2 == null) 
							 {
							     String packageName = className.substring(0,className.lastIndexOf("."));
							     String XMLTypeParam = param.getQName().getLocalPart();
							     Class objectClass = Class.forName(getClassHolderName(XMLTypeParam, packageName));
							     obj2 = (javax.xml.rpc.holders.Holder)objectClass.newInstance();
						     
							     Field valueField = objectClass.getField("value"); 
							     valueField.set(obj2, obj); 
							     //obj2.value = obj; 
							 }
						     obj = obj2;   
						 }
					     else
						 {
						     //cas when obj = null (xsi:nil=true) or param out omited
						     Class objClass = getJavaTypeHolder(param.getQName().getLocalPart(),param.getQName().getNamespaceURI());
						     if (objClass != null) obj = objClass.newInstance();
						     else
							 {
							     String packageName = className.substring(0,className.lastIndexOf("."));
							     String XMLTypeParam = param.getQName().getLocalPart();
							     Class objectClass = Class.forName(getClassHolderName(XMLTypeParam, packageName));
							     obj = (javax.xml.rpc.holders.Holder)objectClass.newInstance();
							 }
						 }
					 }
				 }			 		     
			     if (param.getMode().equals("OUT"))
				 {
				     //cas when obj = null (xsi:nil=true) or param out omited  
				     Class objClass = getJavaTypeHolder(param.getQName().getLocalPart(),param.getQName().getNamespaceURI());

				     if (objClass != null) obj = objClass.newInstance();
				     else
					 {
					     String packageName = className.substring(0,className.lastIndexOf("."));
					     String XMLTypeParam = param.getQName().getLocalPart();
					     Class objectClass = Class.forName(getClassHolderName(XMLTypeParam, packageName));
					     obj = (javax.xml.rpc.holders.Holder)objectClass.newInstance();
					 }
				 }
			     
			     if (obj != null) 
				 {
				     parameterJAVATypes[i] =  typeRegistry.getJavaClass(param.getQName()); 

 				     if (parameterJAVATypes[i] == null || !param.getMode().equals("IN")) parameterJAVATypes[i] = obj.getClass(); 
				 }
			     else parameterJAVATypes[i] =  typeRegistry.getJavaClass(param.getQName()); 
			     parameterValues[i] = obj;
			     i++;
			 }
		 }    
		 catch (Exception ex)
		 {
		     ex.printStackTrace();
		     bool = false;
		     SOAPException = new javax.xml.rpc.soap.SOAPFaultException(QName.valueOf("Client"), "SOAP Message unknow", service.getServiceName(), null);
		 }
	     
	     // 
		 if (bool)
		 {
		     try
			 {
		     	SOAPRequest forReturn = new SOAPRequest();
		     	forReturn.setClassName(className);
		     	forReturn.setOperation(operationName);
		     	forReturn.setServiceName(serviceName);
		     	forReturn.setParametersJAVAType(parameterJAVATypes);
		     	forReturn.setParametersValue(parameterValues);
		     	forReturn.setHasReturn(methodHasReturn);
		     	return forReturn;
			 }
		     catch (Exception ex)
			 {
			     bool = false;
			     SOAPException = new javax.xml.rpc.soap.SOAPFaultException(QName.valueOf("Client"), "Execution service error", service.getServiceName(), null);
			 }     
		 }
	 
 return null;
}
    
public String SOAPResponse(Object result, Object[] parameterValues, String serviceName, QName operationName)
{
	try
	{
 		Service service = objectServices.getService(serviceName);
 		Operation operation = service.getOperation(operationName);
 		SOAPMessage sOAPMessage = new SOAPMessageImpl();
 		SOAPPartImpl sOAPPartR = (SOAPPartImpl)sOAPMessage.getSOAPPart();
 		SOAPEnvelopeImpl sOAPEnvelopeR = (SOAPEnvelopeImpl)sOAPPartR.getEnvelope();
 		sOAPEnvelopeR.createName("Envelope","SOAP-ENV","http://schemas.xmlsoap.org/soap/envelope/");
 		sOAPEnvelopeR.setEncodingStyle("http://schemas.xmlsoap.org/soap/encoding/");
 		sOAPEnvelopeR.addNamespaceDeclaration("xsi","http://www.w3.org/1999/XMLSchema-instance");
     
 		SOAPBodyImpl sOAPBobyR = (SOAPBodyImpl)sOAPEnvelopeR.getBody();
     
 		SOAPBodyElementImpl sOAPBodyElementR = (SOAPBodyElementImpl)sOAPBobyR.addBodyElement(new NameImpl(operationName.getLocalPart()+"Response","ns",operationName.getNamespaceURI()));
	 
 		if (operation.getReturnType() != null)
		 {  
 			System.out.println("Operation return type is "+operation.getReturnType().toString());
 			typeMapping = typeRegistry.getTypeMapping(operation.getReturnType().getNamespaceURI());     
 			serializerFactory = typeMapping.getSerializer(null, operation.getReturnType());
 			serializer = (SerializerBase) serializerFactory.getSerializerAs("default");
 			SOAPElementImpl element = (SOAPElementImpl)serializer.serialize(result,new NameImpl(operationName.getLocalPart()+"Result","ns",operationName.getNamespaceURI()),sOAPBodyElementR,typeRegistry);
			System.out.println("element.getElementName()="+element.getElementName().getLocalName());
			sOAPBodyElementR.addChildElement(element);
		 }
 		
	     //  Serialize the OUTPUT Parameters
	     Iterator params = operation.getParameters();
	     
	     
	     
	     int i2 = 0;
	     while (params.hasNext())
	      {
		   parameterOperation param = (parameterOperation)params.next();
		   System.out.println("param.getName()="+ param.getName());
		   if (!param.getMode().equals("IN"))
		       {
			  // without convertion 14h29 2003-10-14
			   sOAPBodyElementR.addNamespaceDeclaration("ns"+(i2+1),param.getQName().getNamespaceURI());
			   if (parameterValues[i2] != null)
			       {
			   		try
				       {
				   		Field valueField = parameterValues[i2].getClass().getField("value"); 
				   		if (valueField != null) parameterValues[i2] = valueField.get(parameterValues[i2]); 
				       }
				   catch(Exception ex)
				       {
					   	System.out.println("Error in Class Holder value");
				       }
			       }
			   else System.out.println("the param "+param.getName()+" is null");
			   typeMapping = typeRegistry.getTypeMapping(param.getQName().getNamespaceURI());
			   serializerFactory = typeMapping.getSerializer(null, param.getQName());
			   serializer = (SerializerBase) serializerFactory.getSerializerAs("default");
			   sOAPBodyElementR.addChildElement((SOAPElementImpl)serializer.serialize(parameterValues[i2],new NameImpl(param.getName()), sOAPBodyElementR, typeRegistry));
		       }
		   i2++;
	       }
	 sOAPMessage.saveChanges();
	 ByteArrayOutputStream forReturn = new ByteArrayOutputStream();
     sOAPMessage.writeTo(forReturn);
     System.gc();
	 return forReturn.toString();
	}
     catch (Exception ex)
	 {
	     System.out.println("Error in response");
	     return "";
	 }
     
    }
  
 public static void main(String[] args)
 {
 	try
	{
 	SOAPTools app = new SOAPTools("configuration/MSDDeploy.wsdd");
 	//*************** MSD Desc
/*
 	ServiceDescriptionImpl msdService = new ServiceDescriptionImpl();
 	// will be changed and use the caneva given by MSD
 	org.ubisec.msd.impl.ServiceDefinitionImpl msdServiceDefinition = new org.ubisec.msd.impl.ServiceDefinitionImpl();
         
 	OriginalImpl msdOriginal = new OriginalImpl();
 	msdOriginal.setProtocolName("UPnP");
 	msdOriginal.setDescription("UPnP Siemens Implementation");
         
 	GenericImpl msdGeneric = new GenericImpl();
 	// set all the infos that are possible
 	String serviceName = "Service1:Example";
 	msdGeneric.setName(serviceName);
				
	// address
	org.ubisec.msd.impl.AddressImpl address = new org.ubisec.msd.impl.AddressImpl();
	msdGeneric.setAddress(address);
	// binding 
	org.ubisec.msd.impl.BindingImpl binding = new org.ubisec.msd.impl.BindingImpl();
	binding.setEncoding("XML 1.0");
	binding.setTransport("HTTP/SOAP");
	msdGeneric.setBinding(binding);
	// attributes
	org.ubisec.msd.impl.AttributeImpl attribute = new org.ubisec.msd.impl.AttributeImpl();
	java.util.List attributes = msdGeneric.getAttributes();
	attributes.add(attribute);
	
	org.ubisec.msd.impl.MethodImpl method = new org.ubisec.msd.impl.MethodImpl();
	method.setName("setName");							
	
	org.ubisec.msd.impl.ParamImpl param = new org.ubisec.msd.impl.ParamImpl();
	param.setName("name");
	param.setType("string");
	List inputs = method.getInputs();
	inputs.add(param);
	
	org.ubisec.msd.impl.ParamImpl param2 = new org.ubisec.msd.impl.ParamImpl();
	param2.setName("return");
	param2.setType("string");
	List outputs = method.getOutputs();
	outputs.add(param2);
	
		
	List methods = msdGeneric.getMethods();
	methods.add(method);
				
	//	creation time
	Calendar currentTime = Calendar.getInstance();
	currentTime.setTimeInMillis(System.currentTimeMillis());
	msdGeneric.setCreationTime(currentTime);
					
	//Expected life time
	Calendar expectedLifeTime = Calendar.getInstance();
	expectedLifeTime.setTimeInMillis(System.currentTimeMillis()+30000);
	msdGeneric.setExpectedLifetime(expectedLifeTime);
	
	msdServiceDefinition.setGeneric(msdGeneric);
	msdServiceDefinition.setOriginal(msdOriginal);
	msdService.setServiceDefinition(msdServiceDefinition);
	
		

	ServiceDescriptionImpl[] result = new ServiceDescriptionImpl[1];
	result[0] = msdService;
	
	String SOAPMessage = app.SOAPResponse(result , new Object[0] , "MSDClientAPI", QName.valueOf("{urn:MSDClientAPIService}getServices"))  ;
	System.out.println("SOAPMessage:");
	System.out.println(SOAPMessage);
	*/
 	
 	
 	
 	
 	
 	
 	
	//**************************************** *****************
	//  *************** test ServiceRequest ***********************
	//************************************* *****************
 	
 	/*
    ServiceRequestImpl serviceRequest = new ServiceRequestImpl();
	ReqDescriptionInformation reqDescription = new ReqDescriptionInformationImpl();
	
	RequestService requestService = new RequestServiceImpl();
	//requestService.setName("uuid:0000E8699FB4:urn:schemas-upnp-org:service:service1:1:0");
	//requestService.setName("urn:schemas-upnp-org:service:service1:1:0");
	//requestService.setName("uuid:0000E8699FB4:service1");
	requestService.setName("service1");
	// Required Methods 
    List methods = requestService.getMethods();
    Method method = new MethodImpl();
    method.setName("setName");
    List paramIn  = method.getInputs();
    List paramOut = method.getOutputs();
    
    Param param1 = new ParamImpl();
    param1.setName("name");
    
    Param param2 = new ParamImpl();
    param2.setName("return");
    
    paramIn.add(param1);
    paramOut.add(param2);
    
    methods.add(method);
        
    Method method2 = new MethodImpl();
    method2.setName("getName");
    
    List paramOut2 = method2.getOutputs();
    	    	    
    Param param22 = new ParamImpl();
    param22.setName("return");
    
    paramOut2.add(param22);
    
    methods.add(method2);
    
	reqDescription.setService(requestService);
    serviceRequest.setDescription(reqDescription);
    
    String SOAPMessage = app.SOAPResponse(serviceRequest , new Object[0] , "MSDClientAPI", QName.valueOf("{urn:MSDClientAPIService}just4test"))  ;
	System.out.println("SOAPMessage:");
	System.out.println(SOAPMessage);
	
	FileOutputStream soapFile = new FileOutputStream("/home/rafik/soapFile");
	
	soapFile.write(SOAPMessage.getBytes());
	soapFile.close();
	*/
	
 	
 	// 		**************************************** *****************
	//  *************** test SOAPTools Request ***********************
	//************************************* *****************
 	FileInputStream soapFile = new FileInputStream("configuration/soapRequest");
 	
 	SOAPRequest soapRequest = (SOAPRequest)app.SOAP2Java(soapFile,"MSDClientAPI");
 	System.out.println("soapRequest.getServiceName()="+soapRequest.getServiceName());
 	System.out.println("soapRequest.getOperation()="+soapRequest.getOperation().toString());
 	System.out.println("soapRequest.getClass()="+soapRequest.getParametersJAVAType()[0].getName());
 	MSDRequestImpl serviceRequest = (MSDRequestImpl)soapRequest.getParametersValue()[0];
 	System.out.println("serviceRequest.getDescription().getService().getName()="+serviceRequest.getDescInfo().getService().getName());
 	System.out.println("serviceRequest.getDescription().method.size()="+serviceRequest.getDescInfo().getService().getMethods().size());
 	List methods = serviceRequest.getDescInfo().getService().getMethods();
 	for (int m=0; m<methods.size(); m++)
 	 	{
 		org.msda.msd.Method method = (org.msda.msd.Method)methods.get(m);
 		System.out.println(method.getName());
 		List inputs = method.getIn();
 		List outputs = method.getOut();
 		for (int z=0; z<inputs.size(); z++)
 		{
 			Param param = (Param)inputs.get(z);
 			System.out.println("Param = "+param.getValue()+" type = "+param.getType());
 		}
 		for (int z=0; z<outputs.size(); z++)
 		{
 			Param param = (Param)outputs.get(z);
 			System.out.println("Param = "+param.getValue()+" type = "+param.getType());
 		}
 	 	}
 	
 	
 	
	
	}
 	catch(Exception ex)
	{
 		ex.printStackTrace();
	}
   
 }
 
}
		    
